﻿using System.Collections.Generic;
using System.Data;

using Butterfly.Storage;

namespace Butterfly.HabboHotel.Advertisements
{
    class AdvertisementManager
    {
        internal List<RoomAdvertisement> RoomAdvertisements;

        internal AdvertisementManager()
        {
            RoomAdvertisements = new List<RoomAdvertisement>();
        }

        internal void LoadRoomAdvertisements(DatabaseClient dbClient)
        {
            RoomAdvertisements.Clear();

            DataTable Data = dbClient.ReadDataTable("SELECT * FROM room_ads WHERE enabled = '1'");

            if (Data == null)
            {
                return;
            }

            foreach (DataRow Row in Data.Rows)
            {
                RoomAdvertisements.Add(new RoomAdvertisement((uint)Row["id"], (string)Row["ad_image"],
                    (string)Row["ad_link"], (int)Row["views"], (int)Row["views_limit"]));
            }
        }
        internal RoomAdvertisement GetRandomRoomAdvertisement()
        {
            if (RoomAdvertisements.Count <= 0)
            {
                return null;
            }

            while (true)
            {
                int RndId = ButterflyEnvironment.GetRandomNumber(0, (RoomAdvertisements.Count - 1));

                if (RoomAdvertisements[RndId] != null && !RoomAdvertisements[RndId].ExceededLimit)
                {
                    return RoomAdvertisements[RndId];
                }
            }
        }
    }
}
