﻿using System;
using System.Data;
using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages;
using Butterfly.Storage;

namespace Butterfly.HabboHotel.Catalogs
{
    class VoucherHandler
    {
        private static Boolean IsValidCode(string Code)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("code", Code);

                if (dbClient.ReadDataRow("SELECT null FROM credit_vouchers WHERE code = @code LIMIT 1") != null)
                {
                    return true;
                }
            }

            return false;
        }

        internal static int GetVoucherValue(string Code)
        {
            DataRow Data;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("code", Code);
                Data = dbClient.ReadDataRow("SELECT value FROM credit_vouchers WHERE code = @code LIMIT 1");
            }

            if (Data != null)
            {
                return (int)Data[0];
            }

            return 0;
        }

        private static void TryDeleteVoucher(string Code)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("code", Code);
                dbClient.ExecuteQuery("DELETE FROM credit_vouchers WHERE code = @code LIMIT 1");
            }
        }

        internal static void TryRedeemVoucher(GameClient Session, string Code)
        {
            if (!IsValidCode(Code))
            {
                ServerMessage Error = new ServerMessage(213);
                Error.AppendRawInt32(1);
                Session.SendMessage(Error);
                return;
            }

            int Value = GetVoucherValue(Code);

            TryDeleteVoucher(Code);

            if (Value > 0)
            {
                Session.GetHabbo().Credits += Value;
                Session.GetHabbo().UpdateCreditsBalance();
            }

            Session.SendMessage(new ServerMessage(212));
        }
    }
}
