﻿using Butterfly.Core;

namespace Butterfly_Emulator.HabboHotel.Items
{
    enum InteractionType
    {
        none, //None == default
        gate,
        postit,
        roomeffect,
        dimmer,
        trophy,
        bed,
        scoreboard,
        vendingmachine,
        alert,
        onewaygate,
        loveshuffler,
        habbowheel,
        dice,
        bottle,
        teleport,
        rentals,
        pet,
        pool,
        roller,
        fbgate,
        pet0,
        pet1,
        pet2,
        pet3,
        pet4,
        pet5,
        pet6,
        pet7
    }

    class InterractionTypes
    {
        internal static InteractionType GetTypeFromString(string pType)
        {
            switch (pType)
            {
                case "":
                case "default":
                    return InteractionType.none;
                case "gate":
                    return InteractionType.gate;
                case "postit":
                    return InteractionType.postit;
                case "roomeffect":
                    return InteractionType.roomeffect;
                case "dimmer":
                    return InteractionType.dimmer;
                case "trophy":
                    return InteractionType.trophy;
                case "bed":
                    return InteractionType.bed;
                case "scoreboard":
                    return InteractionType.scoreboard;
                case "vendingmachine":
                    return InteractionType.vendingmachine;
                case "alert":
                    return InteractionType.alert;
                case "onewaygate":
                    return InteractionType.onewaygate;
                case "loveshuffler":
                    return InteractionType.loveshuffler;
                case "habbowheel":
                    return InteractionType.habbowheel;
                case "dice":
                    return InteractionType.dice;
                case "bottle":
                    return InteractionType.bottle;
                case "teleport":
                    return InteractionType.teleport;
                case "rentals":
                    return InteractionType.rentals;
                case "pet":
                    return InteractionType.pet;
                case "pool":
                    return InteractionType.pool;
                case "roller":
                    return InteractionType.roller;
                case "fbgate":
                    return InteractionType.fbgate;
                case "pet0":
                    return InteractionType.pet0;
                case "pet1":
                    return InteractionType.pet1;
                case "pet2":
                    return InteractionType.pet2;
                case "pet3":
                    return InteractionType.pet3;
                case "pet4":
                    return InteractionType.pet4;
                case "pet5":
                    return InteractionType.pet5;
                case "pet6":
                    return InteractionType.pet6;
                case "pet7":
                    return InteractionType.pet7;

                default:
                    {
                        Logging.LogException("Unknown interaction type in parse code: " + pType);
                        return InteractionType.none;
                    }
            }
        }

        internal static string ToString(InteractionType pType)
        {
            switch (pType)
            {

                case InteractionType.none:
                    return "default";
                case InteractionType.gate:
                    return "gate";
                case InteractionType.postit:
                    return "postit";
                case InteractionType.roomeffect:
                    return "roomeffect";
                case InteractionType.dimmer:
                    return "dimmer";
                case InteractionType.trophy:
                    return "trophy";
                case InteractionType.bed:
                    return "bed";
                case InteractionType.scoreboard:
                    return "scoreboard";
                case InteractionType.vendingmachine:
                    return "vendingmachine";
                case InteractionType.alert:
                    return "alert";
                case InteractionType.onewaygate:
                    return "onewaygate";
                case InteractionType.loveshuffler:
                    return "loveshuffler";
                case InteractionType.habbowheel:
                    return "habbowheel";
                case InteractionType.dice:
                    return "dice";
                case InteractionType.bottle:
                    return "bottle";
                case InteractionType.teleport:
                    return "teleport";
                case InteractionType.rentals:
                    return "rentals";
                case InteractionType.pet:
                    return "pet";
                case InteractionType.pool:
                    return "pool";
                case InteractionType.roller:
                    return "roller";
                case InteractionType.fbgate:
                    return "fbgate";
                case InteractionType.pet0:
                    return "pet0";
                case InteractionType.pet1:
                    return "pet1";
                case InteractionType.pet2:
                    return "pet2";
                case InteractionType.pet3:
                    return "pet3";
                case InteractionType.pet4:
                    return "pet4";
                case InteractionType.pet5:
                    return "pet5";
                case InteractionType.pet6:
                    return "pet6";
                case InteractionType.pet7:
                    return "pet7";
                default:
                    {
                        Logging.LogException("Unknown interaction type in to string code: " + pType);
                        return "default";
                    }
            }
        }
    }
}
