﻿using System;
using System.Collections.Generic;
using System.Data;
using Butterfly.Core;
using Butterfly.Storage;
using Butterfly_Emulator.HabboHotel.Items;

namespace Butterfly.HabboHotel.Items
{
    class ItemManager
    {
        private Dictionary<UInt32, Item> Items;

        internal ItemManager()
        {
            Items = new Dictionary<uint, Item>();
        }

        internal void LoadItems(DatabaseClient dbClient)
        {
            Items = new Dictionary<uint, Item>();

            DataTable ItemData = dbClient.ReadDataTable("SELECT * FROM furniture;");

            if (ItemData != null)
            {
                foreach (DataRow Row in ItemData.Rows)
                {
                    try
                    {
                        Items.Add((uint)Row["id"], new Item((uint)Row["id"], (int)Row["sprite_id"], (string)Row["public_name"],
                            (string)Row["item_name"], (string)Row["type"], (int)Row["width"], (int)Row["length"],
                            (Double)Row["stack_height"], ButterflyEnvironment.EnumToBool(Row["can_stack"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["is_walkable"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["can_sit"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["allow_recycle"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["allow_trade"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["allow_marketplace_sell"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["allow_gift"].ToString()),
                            ButterflyEnvironment.EnumToBool(Row["allow_inventory_stack"].ToString()),
                            InterractionTypes.GetTypeFromString((string)Row["interaction_type"]), (int)Row["interaction_modes_count"], (string)Row["vending_ids"]));

                    }

                    catch (Exception)
                    {
                        Logging.WriteLine("Could not load item #" + (uint)Row["id"] + ", please verify the data is okay.");
                    }
                }
            }
        }

        internal Boolean ContainsItem(uint Id)
        {
            return Items.ContainsKey(Id);
        }

        internal Item GetItem(uint Id)
        {
            if (ContainsItem(Id))
            {
                return Items[Id];
            }

            return null;
        }
    }
}
