﻿using System;
using Butterfly.Core;
using Butterfly.HabboHotel.Catalogs;
using Butterfly.Messages;

namespace Butterfly.HabboHotel.Items
{
    class UserItem
    {
        internal UInt32 Id;
        internal UInt32 BaseItem;
        internal string ExtraData;
        private Item mBaseItem;

        internal UserItem(UInt32 Id, UInt32 BaseItem, string ExtraData)
        {
            this.Id = Id;
            this.BaseItem = BaseItem;
            this.ExtraData = ExtraData;
            this.mBaseItem = GetBaseItem();
        }

        internal void Serialize(ServerMessage Message)
        {
            Message.AppendUInt(Id);
            if (mBaseItem == null)
                Logging.LogException("Unknown base: " + BaseItem);
            Message.AppendStringWithBreak(mBaseItem.Type.ToString().ToUpper());
            Message.AppendString("qpzZIB");
            Message.AppendInt32(mBaseItem.SpriteId);

            if (mBaseItem.Name.Contains("floor"))
                Message.AppendInt32(3);
            else if (mBaseItem.Name.Contains("wallpaper"))
                Message.AppendInt32(2);
            else if (mBaseItem.Name.Contains("landscape"))
                Message.AppendInt32(4);
            else if (mBaseItem.Type.ToString().ToLower() != "s")
                Message.AppendInt32(0);
            else
                Message.AppendInt32(1);

            Message.AppendStringWithBreak(ExtraData);
            Message.AppendBoolean(mBaseItem.AllowRecycle);
            Message.AppendBoolean(mBaseItem.AllowTrade);
            Message.AppendBoolean(mBaseItem.AllowInventoryStack);
            Message.AppendBoolean(Marketplace.CanSellItem(this));
            Message.AppendInt32(-1);

            if (mBaseItem.Type.ToString().ToLower() == "s")
            {
                Message.AppendStringWithBreak("");
                Message.AppendInt32(0);
            }
        }

        internal Item GetBaseItem()
        {
            return ButterflyEnvironment.GetGame().GetItemManager().GetItem(BaseItem);
        }
    }
}
