﻿using System;
using System.Threading;
using System.Threading.Tasks;
using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;

namespace Butterfly.HabboHotel.Misc
{
    class PixelManager
    {
        private const int RCV_EVERY_MINS = 15;
        private const int RCV_AMOUNT = 50;

        internal Boolean KeepAlive;

        private Task WorkerThread;

        internal PixelManager()
        {
            this.KeepAlive = true;
            this.WorkerThread = new Task(Process);
        }

        internal void Start()
        {
            this.WorkerThread.Start();
        }

        //internal static DateTime LastExecuted;

        private void Process()
        {
            while (KeepAlive)
            {
                try
                {
                    //LastExecuted = DateTime.Now;
                    if (ButterflyEnvironment.GetGame() != null && ButterflyEnvironment.GetGame().GetClientManager() != null)
                        ButterflyEnvironment.GetGame().GetClientManager().CheckPixelUpdates();
                }
                catch (Exception e) { Logging.LogThreadException(e.ToString(), "Pixelmanager task"); }
                Thread.Sleep(15000);
            }
        }

        internal static Boolean NeedsUpdate(GameClient Client)
        {
            try
            {
                if (Client.GetHabbo() == null)
                    return false;

                Double PassedMins = (ButterflyEnvironment.GetUnixTimestamp() - Client.GetHabbo().LastActivityPointsUpdate) / 60;

                if (PassedMins >= RCV_EVERY_MINS)
                {
                    return true;
                }
            }
            catch { }
            return false;
        }

        internal static void GivePixels(GameClient Client)
        {
            Double Timestamp = ButterflyEnvironment.GetUnixTimestamp();

            Client.GetHabbo().LastActivityPointsUpdate = Timestamp;
            Client.GetHabbo().ActivityPoints += RCV_AMOUNT;
            Client.GetHabbo().UpdateActivityPointsBalance(RCV_AMOUNT);
        }
    }
}
