﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages;
using Butterfly.Storage;

namespace Butterfly.HabboHotel.Support
{
    class ModerationTool
    {
        #region General

        internal List<SupportTicket> Tickets;

        internal List<string> UserMessagePresets;
        internal List<string> RoomMessagePresets;

        internal ModerationTool()
        {
            Tickets = new List<SupportTicket>();
            UserMessagePresets = new List<string>();
            RoomMessagePresets = new List<string>();
        }

        internal ServerMessage SerializeTool()
        {
            ServerMessage Response = new ServerMessage(531);
            Response.AppendInt32(-1);

            Response.AppendInt32(UserMessagePresets.Count);
            using (TimedLock.Lock(UserMessagePresets))
            {
                foreach (String Preset in UserMessagePresets)
                {
                    Response.AppendStringWithBreak(Preset);
                }
            }
            Response.AppendUInt(6); //Mod Actions Count

            Response.AppendStringWithBreak("Room Problems"); // modaction Cata
            Response.AppendUInt(8); // ModAction Count
            Response.AppendStringWithBreak("Door Problem"); // mod action Cata
            Response.AppendStringWithBreak("Stop blocking the doors Please"); // Msg
            Response.AppendStringWithBreak("Ban-Problem"); // Mod Action Cata
            Response.AppendStringWithBreak("This your last warning or you received a ban"); // Msg
            Response.AppendStringWithBreak("Help Support");// Mod Action Cata
            Response.AppendStringWithBreak("Please Contact The Player Support For this problem"); // Msg
            Response.AppendStringWithBreak("Bobba Filter"); // Mod Cata
            Response.AppendStringWithBreak("Please stop Playing with the Bobba Filter"); // Msg
            Response.AppendStringWithBreak("Kick user"); // Mod Cata
            Response.AppendStringWithBreak("Please stop Kicking people without a Reason"); // Msg
            Response.AppendStringWithBreak("Ban Room"); // Mod Cata
            Response.AppendStringWithBreak("Please stop banning people without a good reason"); // Msg
            Response.AppendStringWithBreak("RoomName"); // Mod Cata
            Response.AppendStringWithBreak("Please Change your RoomName otherwish we will do it."); // Msg
            Response.AppendStringWithBreak("PH box"); // Mod Cata
            Response.AppendStringWithBreak("Please Contact A administrator about your problem"); // Msg

            Response.AppendStringWithBreak("Player Support");// modaction Cata
            Response.AppendUInt(8); // ModAction Count
            Response.AppendStringWithBreak("Player Bug"); // mod action Cata
            Response.AppendStringWithBreak("Thank you for supporting us and reporting this bug"); // Msg
            Response.AppendStringWithBreak("Login Problem"); // Mod Action Cata
            Response.AppendStringWithBreak("We contact to the player support and will work on your problem"); // Msg
            Response.AppendStringWithBreak("Help Support");// Mod Action Cata
            Response.AppendStringWithBreak("Please Contact The Player Support For this problem"); // Msg
            Response.AppendStringWithBreak("Call for help Filter"); // Mod Cata
            Response.AppendStringWithBreak("Please stop Playing with the CFH Filter"); // Msg
            Response.AppendStringWithBreak("Privacy"); // Mod Cata
            Response.AppendStringWithBreak("You should not give your privacy stuff away."); // Msg
            Response.AppendStringWithBreak("Warning Swf."); // Mod Cata
            Response.AppendStringWithBreak("Please Contact a administrator/moderator."); // Msg
            Response.AppendStringWithBreak("Cache"); // Mod Cata
            Response.AppendStringWithBreak("if you got problems with memmory Please report it"); // Msg
            Response.AppendStringWithBreak("Temp Problem"); // Mod Cata
            Response.AppendStringWithBreak("Delete your temp!"); // Msg

            Response.AppendStringWithBreak("Users Problems");// modaction Cata
            Response.AppendUInt(8); // ModAction Count
            Response.AppendStringWithBreak("Scamming"); // mod action Cata
            Response.AppendStringWithBreak("We will Check the problem for you now can you give us more infomation about what's happens"); // Msg
            Response.AppendStringWithBreak("Trading Scam"); // Mod Action Cata
            Response.AppendStringWithBreak("What happens and how happens please explain us"); // Msg
            Response.AppendStringWithBreak("Disconnection");// Mod Action Cata
            Response.AppendStringWithBreak("Please Contact The Player Support For this problem"); // Msg
            Response.AppendStringWithBreak("Room blocking"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Freezing"); // Mod Cata
            Response.AppendStringWithBreak("Can explain us what happens?"); // Msg
            Response.AppendStringWithBreak("Error page"); // Mod Cata
            Response.AppendStringWithBreak("What was the code from your error Example 404"); // Msg
            Response.AppendStringWithBreak("Can't login"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Updates"); // Mod Cata
            Response.AppendStringWithBreak("We always do our best to update everything"); // Msg

            Response.AppendStringWithBreak("Debug Problems");// modaction Cata
            Response.AppendUInt(8); // ModAction Count
            Response.AppendStringWithBreak("Lag"); // mod action Cata
            Response.AppendStringWithBreak("We will Check the problem for you now can you give us more infomation about what's happens"); // Msg
            Response.AppendStringWithBreak("Disconnection"); // Mod Action Cata
            Response.AppendStringWithBreak("What happens and how happens please explain us"); // Msg
            Response.AppendStringWithBreak("SSO problem");// Mod Action Cata
            Response.AppendStringWithBreak("Please Contact The Player Support For this problem"); // Msg
            Response.AppendStringWithBreak("Char Filter"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("System check"); // Mod Cata
            Response.AppendStringWithBreak("We already checking every debug stuff"); // Msg
            Response.AppendStringWithBreak("Error from WireEncoding"); // Mod Cata
            Response.AppendStringWithBreak("Can you say explain us what happens"); // Msg
            Response.AppendStringWithBreak("Error from BASE64"); // Mod Cata
            Response.AppendStringWithBreak("Can you explain us what happens"); // Msg
            Response.AppendStringWithBreak("Error from Flash player"); // Mod Cata
            Response.AppendStringWithBreak("Can you explain us what happens"); // Msg

            Response.AppendStringWithBreak("System Problems");// modaction Cata
            Response.AppendUInt(8); // ModAction Count
            Response.AppendStringWithBreak("Version"); // mod action Cata
            Response.AppendStringWithBreak("Ask a Administrator For more Information"); // Msg
            Response.AppendStringWithBreak("Swf Version?"); // Mod Action Cata
            Response.AppendStringWithBreak("Currenly We use the same version like Habbo.com"); // Msg
            Response.AppendStringWithBreak("Freeze");// Mod Action Cata
            Response.AppendStringWithBreak("Please Contact The Player Support For this problem"); // Msg
            Response.AppendStringWithBreak("Name Filter"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Nickname Filter"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("System Filter"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Cursing Filter"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Update Filter"); // Mod Cata
            Response.AppendStringWithBreak("We will update your words in the filter Thanks for report."); // Msg

            Response.AppendStringWithBreak("Swf Problems");// modaction Cata
            Response.AppendUInt(8); // ModAction Count
            Response.AppendStringWithBreak("Version"); // mod action Cata
            Response.AppendStringWithBreak("Ask a Administrator For more Information"); // Msg
            Response.AppendStringWithBreak("Swf Version?"); // Mod Action Cata
            Response.AppendStringWithBreak("Currenly We use the same version like Habbo.com"); // Msg
            Response.AppendStringWithBreak("Freeze");// Mod Action Cata
            Response.AppendStringWithBreak("Please Contact The Player Support For this problem"); // Msg
            Response.AppendStringWithBreak("Name Filter"); // Mod Cata
            Response.AppendStringWithBreak("Can you say The usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Crash on loading"); // Mod Cata
            Response.AppendStringWithBreak("Can you explain us what happens"); // Msg
            Response.AppendStringWithBreak("Crash on login"); // Mod Cata
            Response.AppendStringWithBreak("Can you say the usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Crash in room"); // Mod Cata
            Response.AppendStringWithBreak("Can you say the usersname and explain us what happens"); // Msg
            Response.AppendStringWithBreak("Website error"); // Mod Cata
            Response.AppendStringWithBreak("Can you say the usersname and explain us what happens"); // Msg

            Response.AppendStringWithBreak("");
            Response.AppendStringWithBreak("");
            Response.AppendStringWithBreak("");
            Response.AppendStringWithBreak("");
            Response.AppendStringWithBreak("");
            Response.AppendStringWithBreak("");
            Response.AppendStringWithBreak("");

            Response.AppendInt32(RoomMessagePresets.Count);
            using (TimedLock.Lock(RoomMessagePresets))
            {
                foreach (String Preset in RoomMessagePresets)
                {
                    Response.AppendStringWithBreak(Preset);
                }
            }
            Response.AppendStringWithBreak("");
            return Response;
        }

        #endregion

        #region Message Presets

        internal void LoadMessagePresets(DatabaseClient dbClient)
        {
            UserMessagePresets.Clear();
            RoomMessagePresets.Clear();

            DataTable Data = dbClient.ReadDataTable("SELECT type,message FROM moderation_presets WHERE enabled = '1'");

            if (Data == null)
            {
                return;
            }

            foreach (DataRow Row in Data.Rows)
            {
                String Message = (String)Row["message"];

                switch (Row["type"].ToString().ToLower())
                {
                    case "message":

                        UserMessagePresets.Add(Message);
                        break;

                    case "roommessage":

                        RoomMessagePresets.Add(Message);
                        break;
                }
            }
        }

        #endregion

        #region Support Tickets

        internal void LoadPendingTickets(DatabaseClient dbClient)
        {
            DataTable Data = dbClient.ReadDataTable("SELECT id,score,type,status,sender_id,reported_id,moderator_id,message,room_id,room_name,timestamp FROM moderation_tickets WHERE status = 'open' OR status = 'picked'");

            if (Data == null)
            {
                return;
            }

            foreach (DataRow Row in Data.Rows)
            {
                SupportTicket Ticket = new SupportTicket((uint)Row["id"], (int)Row["score"], (int)Row["type"], (uint)Row["sender_id"], (uint)Row["reported_id"], (String)Row["message"], (uint)Row["room_id"], (String)Row["room_name"], (Double)Row["timestamp"]);

                if (Row["status"].ToString().ToLower() == "picked")
                {
                    Ticket.Pick((uint)Row["moderator_id"], false);
                }

                Tickets.Add(Ticket);
            }
        }

        internal void SendNewTicket(GameClient Session, int Category, uint ReportedUser, String Message)
        {
            if (Session.GetHabbo().CurrentRoomId <= 0)
            {
                return;
            }

            RoomData Data = ButterflyEnvironment.GetGame().GetRoomManager().GenerateNullableRoomData(Session.GetHabbo().CurrentRoomId);

            uint TicketId = 0;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("message", Message);
                dbClient.AddParamWithValue("name", Data.Name);

                dbClient.ExecuteQuery("INSERT INTO moderation_tickets (score,type,status,sender_id,reported_id,moderator_id,message,room_id,room_name,timestamp) VALUES (1,'" + Category + "','open','" + Session.GetHabbo().Id + "','" + ReportedUser + "','0',@message,'" + Data.Id + "',@name,'" + ButterflyEnvironment.GetUnixTimestamp() + "')");
                dbClient.ExecuteQuery("UPDATE user_info SET cfhs = cfhs + 1 WHERE user_id = '" + Session.GetHabbo().Id + "' LIMIT 1");

                TicketId = (uint)dbClient.ReadDataRow("SELECT id FROM moderation_tickets WHERE sender_id = '" + Session.GetHabbo().Id + "' ORDER BY id DESC LIMIT 1")[0];
            }

            SupportTicket Ticket = new SupportTicket(TicketId, 1, Category, Session.GetHabbo().Id, ReportedUser, Message, Data.Id, Data.Name, ButterflyEnvironment.GetUnixTimestamp());

            using (TimedLock.Lock(Tickets))
            {
                Tickets.Add(Ticket);
            }

            SendTicketToModerators(Ticket);
        }

        internal void SendOpenTickets(GameClient Session)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.Status != TicketStatus.OPEN && Ticket.Status != TicketStatus.PICKED)
                {
                    continue;
                }

                Session.SendMessage(Ticket.Serialize());
            }
        }

        internal SupportTicket GetTicket(uint TicketId)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.TicketId == TicketId)
                {
                    return Ticket;
                }
            }
            return null;
        }

        internal void PickTicket(GameClient Session, uint TicketId)
        {
            SupportTicket Ticket = GetTicket(TicketId);

            if (Ticket == null || Ticket.Status != TicketStatus.OPEN)
            {
                return;
            }

            Ticket.Pick(Session.GetHabbo().Id, true);
            SendTicketToModerators(Ticket);
        }

        internal void ReleaseTicket(GameClient Session, uint TicketId)
        {
            SupportTicket Ticket = GetTicket(TicketId);

            if (Ticket == null || Ticket.Status != TicketStatus.PICKED || Ticket.ModeratorId != Session.GetHabbo().Id)
            {
                return;
            }

            Ticket.Release(true);
            SendTicketToModerators(Ticket);
        }

        internal void CloseTicket(GameClient Session, uint TicketId, int Result)
        {
            SupportTicket Ticket = GetTicket(TicketId);

            if (Ticket == null || Ticket.Status != TicketStatus.PICKED || Ticket.ModeratorId != Session.GetHabbo().Id)
            {
                return;
            }

            GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(Ticket.SenderId);

            TicketStatus NewStatus;
            int ResultCode;

            switch (Result)
            {
                case 1:

                    ResultCode = 1;
                    NewStatus = TicketStatus.INVALID;
                    break;

                case 2:

                    ResultCode = 2;
                    NewStatus = TicketStatus.ABUSIVE;

                    using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                    {
                        dbClient.ExecuteQuery("UPDATE user_info SET cfhs_abusive = cfhs_abusive + 1 WHERE user_id = '" + Ticket.SenderId + "' LIMIT 1");
                    }

                    break;

                case 3:
                default:

                    ResultCode = 0;
                    NewStatus = TicketStatus.RESOLVED;
                    break;
            }

            if (Client != null)
            {
                Client.GetMessageHandler().GetResponse().Init(540);
                Client.GetMessageHandler().GetResponse().AppendInt32(ResultCode);
                Client.GetMessageHandler().SendResponse();
            }

            Ticket.Close(NewStatus, true);
            SendTicketToModerators(Ticket);
        }

        internal Boolean UsersHasPendingTicket(UInt32 Id)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.SenderId == Id && Ticket.Status == TicketStatus.OPEN)
                {
                    return true;
                }
            }
            return false;
        }

        internal void DeletePendingTicketForUser(UInt32 Id)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.SenderId == Id)
                {
                    Ticket.Delete(true);
                    SendTicketToModerators(Ticket);
                    return;
                }
            }
        }

        internal static void SendTicketToModerators(SupportTicket Ticket)
        {
            ButterflyEnvironment.GetGame().GetClientManager().BroadcastMessage(Ticket.Serialize(), "fuse_mod");
        }

        #endregion

        #region Room Moderation

        internal static void PerformRoomAction(GameClient ModSession, uint RoomId, Boolean KickUsers, Boolean LockRoom, Boolean InappropriateRoom)
        {
            Room Room = ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(RoomId);

            if (Room == null)
            {
                return;
            }

            if (LockRoom)
            {
                Room.State = 1;

                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.ExecuteQuery("UPDATE rooms SET state = 'locked' WHERE id = '" + Room.RoomId + "' LIMIT 1");
                }
            }

            if (InappropriateRoom)
            {
                Room.Name = "Inappropriate to Hotel Managament";
                Room.Description = "Inappropriate to Hotel Management";
                Room.Tags.Clear();

                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.ExecuteQuery("UPDATE rooms SET caption = 'Inappropriate to Hotel Management', description = 'Inappropriate to Hotel Management', tags = '' WHERE id = '" + Room.RoomId + "' LIMIT 1");
                }
            }

            if (KickUsers)
            {
                List<RoomUser> ToRemove = new List<RoomUser>();

                for (int i = 0; i < Room.UserList.Length; i++)
                {
                    RoomUser User = Room.UserList[i];
                    if (User == null)
                        continue;
                    if (User == null || User.IsBot || User.GetClient().GetHabbo().Rank >= ModSession.GetHabbo().Rank)
                        continue;

                    ToRemove.Add(User);

                }

                for (int i = 0; i < ToRemove.Count; i++)
                {
                    Room.RemoveUserFromRoom(ToRemove[i].GetClient(), true, false);
                }
            }
        }

        internal static void RoomAlert(uint RoomId, Boolean Caution, String Message)
        {
            Room Room = ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(RoomId);

            if (Room == null || Message.Length <= 1)
            {
                return;
            }

            StringBuilder QueryBuilder = new StringBuilder();

            int j = 0;

            for (int i = 0; i < Room.UserList.Length; i++)
            {
                RoomUser User = Room.UserList[i];
                if (User == null)
                    continue;

                if (User.IsBot)
                {
                    continue;
                }

                User.GetClient().SendNotif(Message, Caution);

                if (j > 0)
                {
                    QueryBuilder.Append(" OR ");
                }

                QueryBuilder.Append("user_id = '" + User.GetClient().GetHabbo().Id + "'");
                j++;

            }


            if (Caution)
            {
                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.ExecuteQuery("UPDATE user_info SET cautions = cautions + 1 WHERE " + QueryBuilder.ToString() + " LIMIT " + j);
                }
            }
        }

        internal static ServerMessage SerializeRoomTool(RoomData Data)
        {
            Room Room = ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(Data.Id);
            UInt32 OwnerId = 0;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                try
                {
                    dbClient.AddParamWithValue("owner", Data.Owner);
                    OwnerId = (uint)dbClient.ReadDataRow("SELECT id FROM users WHERE username = @owner LIMIT 1")[0];
                }
                catch (Exception) { }
            }

            ServerMessage Message = new ServerMessage(538);
            Message.AppendUInt(Data.Id);
            Message.AppendInt32(Data.UsersNow); // user count

            if (Room != null)
            {
                Message.AppendBoolean((Room.GetRoomUserByHabbo(Data.Owner) != null));
            }
            else
            {
                Message.AppendBoolean(false);
            }

            Message.AppendUInt(OwnerId);
            Message.AppendStringWithBreak(Data.Owner);
            Message.AppendUInt(Data.Id);
            Message.AppendStringWithBreak(Data.Name);
            Message.AppendStringWithBreak(Data.Description);
            Message.AppendInt32(Data.TagCount);

            foreach (string Tag in Data.Tags)
            {
                Message.AppendStringWithBreak(Tag);
            }

            if (Room != null)
            {
                Message.AppendBoolean(Room.HasOngoingEvent);

                if (Room.Event != null)
                {
                    Message.AppendStringWithBreak(Room.Event.Name);
                    Message.AppendStringWithBreak(Room.Event.Description);
                    Message.AppendInt32(Room.Event.Tags.Count);

                    using (TimedLock.Lock(Room.Event.Tags))
                    {
                        foreach (string Tag in Room.Event.Tags)
                        {
                            Message.AppendStringWithBreak(Tag);
                        }
                    }
                }
            }
            else
            {
                Message.AppendBoolean(false);
            }

            return Message;
        }

        #endregion

        #region User Moderation

        internal static void KickUser(GameClient ModSession, uint UserId, String Message, Boolean Soft)
        {
            GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);

            if (Client == null || Client.GetHabbo().CurrentRoomId < 1 || Client.GetHabbo().Id == ModSession.GetHabbo().Id)
            {
                return;
            }

            if (Client.GetHabbo().Rank >= ModSession.GetHabbo().Rank)
            {
                ModSession.SendNotif("You do not have permission to kick that user.");
                return;
            }

            Room Room = ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(Client.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            Room.RemoveUserFromRoom(Client, true, false);

            if (!Soft)
            {
                Client.SendNotif(Message);

                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.ExecuteQuery("UPDATE user_info SET cautions = cautions + 1 WHERE user_id = '" + UserId + "' LIMIT 1");
                }
            }
        }

        internal static void AlertUser(GameClient ModSession, uint UserId, String Message, Boolean Caution)
        {
            GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);

            if (Client == null || Client.GetHabbo().Id == ModSession.GetHabbo().Id)
            {
                return;
            }

            if (Caution && Client.GetHabbo().Rank >= ModSession.GetHabbo().Rank)
            {
                ModSession.SendNotif("You do not have permission to caution that user, sending as a regular message instead.");
                Caution = false;
            }

            Client.SendNotif(Message, Caution);

            if (Caution)
            {
                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.ExecuteQuery("UPDATE user_info SET cautions = cautions + 1 WHERE user_id = '" + UserId + "' LIMIT 1");
                }
            }
        }

        internal static void BanUser(GameClient ModSession, uint UserId, int Length, String Message)
        {
            GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);

            if (Client == null || Client.GetHabbo().Id == ModSession.GetHabbo().Id)
            {
                return;
            }

            if (Client.GetHabbo().Rank >= ModSession.GetHabbo().Rank)
            {
                ModSession.SendNotif("You do not have permission to ban that user.");
                return;
            }

            Double dLength = Length;

            ButterflyEnvironment.GetGame().GetBanManager().BanUser(Client, ModSession.GetHabbo().Username, dLength, Message, false);
        }

        #endregion

        #region User Info

        internal static ServerMessage SerializeUserInfo(uint UserId)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataRow User = dbClient.ReadDataRow("SELECT id, username, online FROM users WHERE id = '" + UserId + "' LIMIT 1");
                DataRow Info = dbClient.ReadDataRow("SELECT reg_timestamp, login_timestamp, cfhs, cfhs_abusive, cautions, bans FROM user_info WHERE user_id = '" + UserId + "' LIMIT 1");

                if (User == null)
                {
                    throw new NullReferenceException("No user found in database");
                }

                ServerMessage Message = new ServerMessage(533);

                Message.AppendUInt((uint)User["id"]);
                Message.AppendStringWithBreak((string)User["username"]);

                if (Info != null)
                {
                    Message.AppendInt32((int)Math.Ceiling((ButterflyEnvironment.GetUnixTimestamp() - (Double)Info["reg_timestamp"]) / 60));
                    Message.AppendInt32((int)Math.Ceiling((ButterflyEnvironment.GetUnixTimestamp() - (Double)Info["login_timestamp"]) / 60));
                }
                else
                {
                    Message.AppendInt32(0);
                    Message.AppendInt32(0);
                }

                if (User["online"].ToString() == "1")
                {
                    Message.AppendBoolean(true);
                }
                else
                {
                    Message.AppendBoolean(false);
                }

                if (Info != null)
                {
                    Message.AppendInt32((int)Info["cfhs"]);
                    Message.AppendInt32((int)Info["cfhs_abusive"]);
                    Message.AppendInt32((int)Info["cautions"]);
                    Message.AppendInt32((int)Info["bans"]);
                }
                else
                {
                    Message.AppendInt32(0); // cfhs
                    Message.AppendInt32(0); // abusive cfhs
                    Message.AppendInt32(0); // cautions
                    Message.AppendInt32(0); // bans
                }

                return Message;
            }
        }

        internal static ServerMessage SerializeRoomVisits(UInt32 UserId)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataTable Data = dbClient.ReadDataTable("SELECT room_id,hour,minute FROM user_roomvisits WHERE user_id = '" + UserId + "' ORDER BY entry_timestamp DESC LIMIT 50");

                ServerMessage Message = new ServerMessage(537);
                Message.AppendUInt(UserId);
                Message.AppendStringWithBreak(ButterflyEnvironment.GetGame().GetClientManager().GetNameById(UserId));

                if (Data != null)
                {
                    Message.AppendInt32(Data.Rows.Count);

                    foreach (DataRow Row in Data.Rows)
                    {
                        RoomData RoomData = ButterflyEnvironment.GetGame().GetRoomManager().GenerateNullableRoomData((uint)Row["room_id"]);

                        Message.AppendBoolean(RoomData.IsPublicRoom);
                        Message.AppendUInt(RoomData.Id);
                        Message.AppendStringWithBreak(RoomData.Name);
                        Message.AppendInt32((int)Row["hour"]);
                        Message.AppendInt32((int)Row["minute"]);
                    }
                }
                else
                {
                    Message.AppendInt32(0);
                }

                return Message;
            }
        }

        #endregion

        #region Chatlogs

        internal static ServerMessage SerializeUserChatlog(UInt32 UserId)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataTable Visits = dbClient.ReadDataTable("SELECT room_id,entry_timestamp,exit_timestamp FROM user_roomvisits WHERE user_id = '" + UserId + "' ORDER BY entry_timestamp DESC LIMIT 5");


                ServerMessage Message = new ServerMessage(536);
                Message.AppendUInt(UserId);
                Message.AppendStringWithBreak(ButterflyEnvironment.GetGame().GetClientManager().GetNameById(UserId));

                if (Visits != null)
                {
                    Message.AppendInt32(Visits.Rows.Count);

                    foreach (DataRow Visit in Visits.Rows)
                    {
                        DataTable Chatlogs = null;

                        if ((Double)Visit["exit_timestamp"] <= 0.0)
                        {
                            Visit["exit_timestamp"] = ButterflyEnvironment.GetUnixTimestamp();
                        }

                        //using (DatabaseClient dbClient = UberEnvironment.GetDatabase().GetClient())
                        //{
                        Chatlogs = dbClient.ReadDataTable("SELECT user_id,user_name,hour,minute,message FROM chatlogs WHERE room_id = '" + (uint)Visit["room_id"] + "' AND timestamp > " + (Double)Visit["entry_timestamp"] + " AND timestamp < " + (Double)Visit["exit_timestamp"] + " ORDER BY timestamp DESC");
                        //}

                        RoomData RoomData = ButterflyEnvironment.GetGame().GetRoomManager().GenerateNullableRoomData((UInt32)Visit["room_id"]);

                        Message.AppendBoolean(RoomData.IsPublicRoom);
                        Message.AppendUInt(RoomData.Id);
                        Message.AppendStringWithBreak(RoomData.Name);

                        if (Chatlogs != null)
                        {
                            Message.AppendInt32(Chatlogs.Rows.Count);

                            foreach (DataRow Log in Chatlogs.Rows)
                            {
                                Message.AppendInt32((int)Log["hour"]);
                                Message.AppendInt32((int)Log["minute"]);
                                Message.AppendUInt((UInt32)Log["user_id"]);
                                Message.AppendStringWithBreak((string)Log["user_name"]);
                                Message.AppendStringWithBreak((string)Log["message"]);
                            }
                        }
                        else
                        {
                            Message.AppendInt32(0);
                        }
                    }
                }
                else
                {
                    Message.AppendInt32(0);
                }

                return Message;
            }
        }

        internal static ServerMessage SerializeTicketChatlog(SupportTicket Ticket, RoomData RoomData, Double Timestamp)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataTable Data = dbClient.ReadDataTable("SELECT user_id,user_name,hour,minute,message FROM chatlogs WHERE room_id = '" + RoomData.Id + "' AND timestamp >= '" + (Timestamp - 300) + "' AND timestamp <= '" + Timestamp + "' ORDER BY timestamp DESC");

                ServerMessage Message = new ServerMessage(534);
                Message.AppendUInt(Ticket.TicketId);
                Message.AppendUInt(Ticket.SenderId);
                Message.AppendUInt(Ticket.ReportedId);
                Message.AppendBoolean(RoomData.IsPublicRoom);
                Message.AppendUInt(RoomData.Id);
                Message.AppendStringWithBreak(RoomData.Name);

                if (Data != null)
                {
                    Message.AppendInt32(Data.Rows.Count);

                    foreach (DataRow Row in Data.Rows)
                    {
                        Message.AppendInt32((int)Row["hour"]);
                        Message.AppendInt32((int)Row["minute"]);
                        Message.AppendUInt((UInt32)Row["user_id"]);
                        Message.AppendStringWithBreak((String)Row["user_name"]);
                        Message.AppendStringWithBreak((String)Row["message"]);
                    }
                }
                else
                {
                    Message.AppendInt32(0);
                }

                return Message;
            }
        }

        internal static ServerMessage SerializeRoomChatlog(UInt32 RoomId)
        {
            Room Room = ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(RoomId);

            if (Room == null)
            {
                throw new NullReferenceException("Noo room found.");
            }

            Boolean IsPublic = false;

            if (Room.Type.ToLower() == "public")
            {
                IsPublic = true;
            }

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataTable Data = dbClient.ReadDataTable("SELECT user_id,user_name,hour,minute,message FROM chatlogs WHERE room_id = '" + Room.RoomId + "' ORDER BY timestamp DESC LIMIT 150");

                ServerMessage Message = new ServerMessage(535);
                Message.AppendBoolean(IsPublic);
                Message.AppendUInt(Room.RoomId);
                Message.AppendStringWithBreak(Room.Name);

                if (Data != null)
                {
                    Message.AppendInt32(Data.Rows.Count);

                    foreach (DataRow Row in Data.Rows)
                    {
                        Message.AppendInt32((int)Row["hour"]);
                        Message.AppendInt32((int)Row["minute"]);
                        Message.AppendUInt((UInt32)Row["user_id"]);
                        Message.AppendStringWithBreak((string)Row["user_name"]);
                        Message.AppendStringWithBreak((string)Row["message"]);
                    }
                }
                else
                {
                    Message.AppendInt32(0);
                }

                return Message;
            }
        }
        #endregion
    }
}
