﻿using System;
using System.Data;
using Butterfly.HabboHotel.GameClients;

namespace Butterfly.HabboHotel.Users.Authenticator
{
    static class Authenticator
    {
        internal static Habbo TryLoginHabbo(GameClient Client, HabboData pData, HabboData UserData)
        {
            return GenerateHabbo(pData.GetHabboDataRow, Client, UserData);
        }

        private static Habbo GenerateHabbo(DataRow Data, GameClient Client, HabboData UserData)
        {
            return new Habbo((UInt32)Data["id"], (string)Data["username"], (string)Data["real_name"], 
                (uint)Data["rank"], (string)Data["motto"], (string)Data["look"], 
                (string)Data["gender"], (int)Data["credits"], (int)Data["activity_points"], 
                (Double)Data["activity_points_lastupdate"], ButterflyEnvironment.EnumToBool(Data["is_muted"].ToString()), 
                (UInt32)Data["home_room"], (Int32)Data["respect"], (int)Data["daily_respect_points"], 
                (int)Data["daily_pet_respect_points"], (Data["mutant_penalty"].ToString() != "0"), Client, UserData);
        }

        internal static Habbo GetHabboViaUsername(string Data)
        {
            HabboData UserData = new HabboData(Data, false);
            return GenerateHabbo(UserData.GetHabboDataRow, null, UserData);
        }
    }
}
