﻿using System;
using System.Collections.Generic;
using System.Data;
using Butterfly.Messages;
using Butterfly.Storage;

namespace Butterfly.HabboHotel.Users.Badges
{
    class BadgeComponent
    {
        private List<Badge> Badges;
        private UInt32 UserId;

        internal int Count
        {
            get
            {
                return Badges.Count;
            }
        }

        internal int EquippedCount
        {
            get
            {
                int i = 0;

                //using (TimedLock.Lock(Badges)
                //{
                foreach (Badge Badge in Badges)
                {
                    if (Badge.Slot <= 0)
                    {
                        continue;
                    }

                    i++;
                }
                //}

                return i;
            }
        }

        internal List<Badge> BadgeList
        {
            get
            {
                return Badges;
            }
        }

        internal BadgeComponent(uint UserId, HabboData UserData)
        {
            this.Badges = new List<Badge>();
            this.UserId = UserId;

            DataTable Data = UserData.GetUserBadges;

            if (Data == null)
            {
                return;
            }

            foreach (DataRow Row in Data.Rows)
            {
                //GiveBadge((string)Row["badge_id"], (int)Row["badge_slot"], false); TOO SLOW BIIIATTCHH!!!!
                Badges.Add(new Badge((string)Row["badge_id"], (int)Row["badge_slot"]));
            }
        }

        internal Badge GetBadge(string Badge)
        {
            //using (TimedLock.Lock(Badges)
            //{
            foreach (Badge B in Badges)
            {
                if (Badge.ToLower() == B.Code.ToLower())
                {
                    return B;
                }
            }
            //}

            return null;
        }

        internal Boolean HasBadge(string Badge)
        {
            if (GetBadge(Badge) != null)
            {
                return true;
            }

            return false;
        }

        internal void GiveBadge(string Badge, Boolean InDatabase)
        {
            GiveBadge(Badge, 0, InDatabase);
        }

        internal void GiveBadge(string Badge, int Slot, Boolean InDatabase)
        {
            if (HasBadge(Badge))
            {
                return;
            }

            if (InDatabase)
            {
                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.AddParamWithValue("badge", Badge);
                    dbClient.ExecuteQuery("INSERT INTO user_badges (user_id,badge_id,badge_slot) VALUES ('" + UserId + "',@badge,'" + Slot + "')");
                }
            }

            Badges.Add(new Badge(Badge, Slot));
        }

        //internal void SetBadgeSlot(string Badge, int Slot)
        //{
        //    Badge B = GetBadge(Badge);

        //    if (B == null)
        //    {
        //        return;
        //    }

        //    B.Slot = Slot;
        //}

        internal void ResetSlots()
        {
            //using (TimedLock.Lock(Badges)
            //{
            foreach (Badge Badge in Badges)
            {
                Badge.Slot = 0;
            }
            //}
        }

        internal void RemoveBadge(string Badge)
        {
            if (!HasBadge(Badge))
            {
                return;
            }

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("badge", Badge);
                dbClient.ExecuteQuery("DELETE FROM user_badges WHERE badge_id = @badge AND user_id = '" + UserId + "' LIMIT 1");
            }

            Badges.Remove(GetBadge(Badge));
        }


        internal ServerMessage Serialize()
        {
            List<Badge> EquippedBadges = new List<Badge>();

            ServerMessage Message = new ServerMessage(229);
            Message.AppendInt32(Count);

            //using (TimedLock.Lock(Badges)
            //{
            foreach (Badge Badge in Badges)
            {
                Message.AppendStringWithBreak(Badge.Code);

                if (Badge.Slot > 0)
                {
                    EquippedBadges.Add(Badge);
                }
            }
            //}

            Message.AppendInt32(EquippedBadges.Count);

            foreach (Badge Badge in EquippedBadges)
            {
                Message.AppendInt32(Badge.Slot);
                Message.AppendStringWithBreak(Badge.Code);
            }

            return Message;
        }
    }
}
