﻿using System;
using System.Data;
using Butterfly.Storage;

namespace Butterfly.HabboHotel
{
    class HabboData
    {
        #region Fields
        private bool mUserFound;
        private DataRow mUserInformation;
        private DataTable mAchievementData;
        private DataTable mUserFavouriteRooms;
        private DataTable mUserIgnores;
        private DataTable mUsertags;
        private DataTable mSubscriptionData;
        private DataTable mUserBadges;
        private DataTable mUserInventory;
        private DataTable mUserEffects;
        private DataTable mUserFriends;
        private DataTable mUserRequests;
        private DataTable mUsersRooms;
        private DataTable mUserPets;
        #endregion

        #region Return values
        internal bool UserFound
        {
            get
            {
                return mUserFound;
            }
        }

        internal DataRow GetHabboDataRow
        {
            get
            {
                return mUserInformation;
            }
        }

        internal DataTable GetAchievementData
        {
            get
            {
                return mAchievementData;
            }
        }

        internal DataTable GetUserFavouriteRooms
        {
            get
            {
                return mUserFavouriteRooms;
            }
        }

        internal DataTable GetUserIgnores
        {
            get
            {
                return mUserIgnores;
            }
        }

        internal DataTable GetUserTags
        {
            get
            {
                return mUsertags;
            }
        }

        internal DataTable GetSupscriptionData
        {
            get
            {
                return mSubscriptionData;
            }
        }

        internal DataTable GetUserBadges
        {
            get
            {
                return mUserBadges;
            }
        }

        internal DataTable GetUserInventory
        {
            get
            {
                return mUserInventory;
            }
        }

        internal DataTable GetUserEffects
        {
            get
            {
                return mUserEffects;
            }
        }

        internal DataTable GetFriendList
        {
            get
            {
                return mUserFriends;
            }
        }

        internal DataTable GetFriendReqs
        {
            get
            {
                return mUserRequests;
            }
        }

        internal DataTable GetUsersRooms
        {
            get
            {
                return mUsersRooms;
            }
            set
            {
                mUsersRooms = value;
            }
        }
        internal DataTable GetUserPets
        {
            get
            {
                return mUserPets;
            }
        }
        #endregion

        #region Constructor
        internal HabboData(string pSSOTicket, string pIPAddress, bool LoadFull)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("auth_ticket", pSSOTicket);
                mUserInformation = dbClient.ReadDataRow("SELECT id, username, real_name, rank, motto, look, gender, credits, activity_points, activity_points_lastupdate, is_muted, home_room, respect, daily_respect_points, daily_pet_respect_points, newbie_status, mutant_penalty,block_newfriends FROM users WHERE auth_ticket = @auth_ticket AND ip_last = '" + pIPAddress + "' LIMIT 1;");

                if (mUserInformation != null)
                {
                    mUserFound = true;
                    UInt32 UserID = (UInt32)mUserInformation["id"];

                    if (LoadFull)
                    {
                        mAchievementData = dbClient.ReadDataTable("SELECT achievement_id,achievement_level FROM user_achievements WHERE user_id = '" + UserID + "'");
                        mUserFavouriteRooms = dbClient.ReadDataTable("SELECT room_id FROM user_favorites WHERE user_id = '" + UserID + "'");
                        mUserIgnores = dbClient.ReadDataTable("SELECT ignore_id FROM user_ignores WHERE user_id = '" + UserID + "'");
                        mUsertags = dbClient.ReadDataTable("SELECT tag FROM user_tags WHERE user_id = '" + UserID + "'");
                        mSubscriptionData = dbClient.ReadDataTable("SELECT * FROM user_subscriptions WHERE user_id = '" + UserID + "'");
                        mUserBadges = dbClient.ReadDataTable("SELECT user_badges.badge_id,user_badges.badge_slot FROM user_badges WHERE user_id = " + UserID);
                        mUserInventory = dbClient.ReadDataTable("SELECT user_items.id,user_items.base_item,user_items.extra_data FROM user_items WHERE user_id = " + UserID);
                        mUserEffects = dbClient.ReadDataTable("SELECT user_effects.effect_id,user_effects.total_duration,user_effects.is_activated,user_effects.activated_stamp FROM user_effects WHERE user_id =  " + UserID);

                        mUserFriends = dbClient.ReadDataTable("SELECT users.id,users.username,users.motto,users.look,users.last_online FROM users JOIN messenger_friendships ON users.id = messenger_friendships.user_two_id WHERE messenger_friendships.user_one_id = '" + UserID + "'");
                        mUserRequests = dbClient.ReadDataTable("SELECT messenger_requests.id,messenger_requests.from_id,users.username FROM users JOIN messenger_requests ON users.id = messenger_requests.from_id WHERE messenger_requests.to_id = '" + UserID + "'");

                        dbClient.AddParamWithValue("name", (string)mUserInformation["username"]);
                        mUsersRooms = dbClient.ReadDataTable("SELECT id, caption, description, roomtype, owner, state, category, users_now, users_max, model_name, public_ccts, score, allow_pets, allow_pets_eat, allow_walkthrough, allow_hidewall, password, wallpaper, floor, landscape, icon_items, icon_bg, icon_fg, tags, allow_rightsoverride FROM rooms WHERE owner = @name ORDER BY id ASC");
                        mUserPets = dbClient.ReadDataTable("SELECT id, user_id, room_id, name, type, race, color, expirience, energy, nutrition, respect, createstamp, x, y, z FROM user_pets WHERE user_id = " + UserID + " AND room_id = 0");
                        // auth_ticket = '',
                        dbClient.ExecuteQuery("UPDATE users SET online = '1', ip_last = '" + pIPAddress + "' WHERE id = '" + UserID + "' LIMIT 1; " +
                                              "UPDATE user_info SET login_timestamp = '" + ButterflyEnvironment.GetUnixTimestamp() + "' WHERE user_id = '" + UserID + "' LIMIT 1;");
                    }

                    //Logging.WriteLine("Userdata for user [" + UserID + "] fetched");
                }
                else
                {
                    mUserFound = false;
                }
            }
        }

        internal HabboData(string Username, bool LoadFull)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("username", Username);
                mUserInformation = dbClient.ReadDataRow("SELECT id, username, real_name, rank, motto, look, gender, credits, activity_points, activity_points_lastupdate, is_muted, home_room, respect, daily_respect_points, daily_pet_respect_points, newbie_status, mutant_penalty,block_newfriends FROM users WHERE username = @username LIMIT 1;");

                if (mUserInformation != null)
                {
                    mUserFound = true;
                    UInt32 UserID = (UInt32)mUserInformation["id"];

                    if (LoadFull)
                    {
                        mAchievementData = dbClient.ReadDataTable("SELECT achievement_id,achievement_level FROM user_achievements WHERE user_id = '" + UserID + "'");
                        mUserFavouriteRooms = dbClient.ReadDataTable("SELECT room_id FROM user_favorites WHERE user_id = '" + UserID + "'");
                        mUserIgnores = dbClient.ReadDataTable("SELECT ignore_id FROM user_ignores WHERE user_id = '" + UserID + "'");
                        mUsertags = dbClient.ReadDataTable("SELECT tag FROM user_tags WHERE user_id = '" + UserID + "'");
                        mSubscriptionData = dbClient.ReadDataTable("SELECT subscription_id, timestamp_activated, timestamp_expire FROM user_subscriptions WHERE user_id = '" + UserID + "'");
                        mUserBadges = dbClient.ReadDataTable("SELECT user_badges.badge_id,user_badges.badge_slot FROM user_badges WHERE user_id = " + UserID);
                        mUserInventory = dbClient.ReadDataTable("SELECT user_items.id,user_items.base_item,user_items.extra_data FROM user_items WHERE user_id = " + UserID);
                        mUserEffects = dbClient.ReadDataTable("SELECT user_effects.effect_id,user_effects.total_duration,user_effects.is_activated,user_effects.activated_stamp FROM user_effects WHERE user_id =  " + UserID);

                        mUserFriends = dbClient.ReadDataTable("SELECT users.id,users.username,users.motto,users.look,users.last_online FROM users JOIN messenger_friendships ON users.id = messenger_friendships.user_two_id WHERE messenger_friendships.user_one_id = '" + UserID + "'");
                        mUserRequests = dbClient.ReadDataTable("SELECT messenger_requests.id,messenger_requests.from_id,users.username FROM users JOIN messenger_requests ON users.id = messenger_requests.from_id WHERE messenger_requests.to_id = '" + UserID + "'");

                        dbClient.AddParamWithValue("name", (string)mUserInformation["username"]);
                        mUsersRooms = dbClient.ReadDataTable("SELECT id, caption, description, roomtype, owner, state, category, users_now, users_max, model_name, public_ccts, score, allow_pets, allow_pets_eat, allow_walkthrough, allow_hidewall, password, wallpaper, floor, landscape, icon_items, icon_bg, icon_fg, tags FROM rooms WHERE owner = @name ORDER BY id ASC");

                        //dbClient.ExecuteQuery("UPDATE users SET online = '1', auth_ticket = '', ip_last = '" + pIPAddress + "' WHERE id = '" + UserID + "' LIMIT 1; " +
                        //                      "UPDATE user_info SET login_timestamp = '" + UberEnvironment.GetUnixTimestamp() + "' WHERE user_id = '" + UserID + "' LIMIT 1;");
                    }

                    //Logging.WriteLine("Userdata for user [" + UserID + "] fetched");
                }
                else
                {
                    mUserFound = false;
                }
            }
        }

        #endregion

        internal void Clear()
        {
            mUserInformation.Delete();
            mAchievementData.Clear();
            mUserFavouriteRooms.Clear();
            mUserIgnores.Clear();
            mUsertags.Clear();
            mSubscriptionData.Clear();
            mUserBadges.Clear();
            mUserInventory.Clear();
            mUserEffects.Clear();
            mUserFriends.Clear();
            mUserRequests.Clear();
            mUsersRooms.Clear();
            mUserPets.Clear();
        }
    }
}
