﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages;
using Butterfly.Storage;

namespace Butterfly.HabboHotel.Users.Messenger
{
    class HabboMessenger
    {
        private UInt32 UserId;

        //private List<MessengerBuddy> Buddies;
        //private List<MessengerRequest> Requests;
        private Hashtable mBuddies;
        private Hashtable mRequests;

        internal bool AppearOffline;

        internal HabboMessenger(UInt32 UserId)
        {
            this.mBuddies = new Hashtable();
            this.mRequests = new Hashtable();
            this.UserId = UserId;
        }

        internal void LoadBuddies(DataTable Data)
        {
            mBuddies = new Hashtable();

            //DataTable Data = UserData.GetFriendList;
            //dbClient.ReadDataTable("SELECT users.id,users.username,users.motto,users.look,users.last_online FROM users JOIN messenger_friendships ON users.id = messenger_friendships.user_two_id WHERE messenger_friendships.user_one_id = '" + UserId + "'");

            if (Data == null)
                return;

            foreach (DataRow Row in Data.Rows)
                mBuddies.Add((UInt32)Row["id"], new MessengerBuddy((UInt32)Row["id"], Row["username"] as string, Row["look"] as string, Row["motto"] as string, Row["last_online"] as string));
        }

        internal void LoadRequests(DataTable Data)
        {
            mRequests = new Hashtable();

            //DataTable Data = UserData.GetFriendReqs;
            //dbClient.ReadDataTable("SELECT messenger_requests.id,messenger_requests.from_id,users.username FROM users JOIN messenger_requests ON users.id = messenger_requests.from_id WHERE messenger_requests.to_id = '" + UserId + "'");

            if (Data == null)
            {
                return;
            }

            foreach (DataRow Row in Data.Rows)
            {
                mRequests.Add((UInt32)Row["from_id"], new MessengerRequest(UserId, (UInt32)Row["from_id"], Row["username"] as string));
            }
        }

        //internal void ClearBuddies()
        //{
        //    mBuddies.Clear();
        //}

        internal void ClearRequests()
        {
            mRequests.Clear();
        }

        internal MessengerRequest GetRequest(UInt32 RequestId)
        {
            return mRequests[RequestId] as MessengerRequest;
            //using (TimedLock.Lock(this.Requests))
            //{
            //    List<MessengerRequest>.Enumerator eRequests = this.Requests.GetEnumerator();

            //    while (eRequests.MoveNext())
            //    {
            //        MessengerRequest Request = eRequests.Current;

            //        if (Request.RequestId == RequestId)
            //        {
            //            return Request;
            //        }
            //    }
            //}

            //return null;
        }

        internal void OnStatusChanged(bool instantUpdate)
        {
            Hashtable ClonedBuddies = mBuddies.Clone() as Hashtable;

            foreach (MessengerBuddy Buddy in ClonedBuddies.Values)
            {
                try
                {
                    GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(Buddy.Id);

                    if (Client == null || Client.GetHabbo() == null || Client.GetHabbo().GetMessenger() == null)
                    {
                        continue;
                    }

                    Client.GetHabbo().GetMessenger().SetUpdateNeeded(UserId);

                    if (instantUpdate)
                    {
                        Client.GetHabbo().GetMessenger().ForceUpdate();
                    }
                }
                catch { }
            }

            ClonedBuddies.Clear();
            //ClonedBuddies = null;
        }

        internal bool SetUpdateNeeded(UInt32 pUserId)
        {
            Hashtable ClonedBuddies = mBuddies.Clone() as Hashtable;

            foreach (MessengerBuddy Buddy in ClonedBuddies.Values)
            {
                if (Buddy.Id == pUserId)
                {
                    Buddy.UpdateNeeded = true;
                    return true;
                }
            }

            return false;
        }

        internal void ForceUpdate()
        {
            this.GetClient().SendMessage(this.SerializeUpdates());
        }

        internal static Boolean RequestExists(UInt32 UserOne, UInt32 UserTwo)
        {
            if (UserOne == UserTwo)
            {
                return true;
            }

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                if (dbClient.ReadDataRow("SELECT id FROM messenger_requests WHERE to_id = '" + UserOne + "' AND from_id = '" + UserTwo + "' LIMIT 1") != null)
                {
                    return true;
                }

                if (dbClient.ReadDataRow("SELECT id FROM messenger_requests WHERE to_id = '" + UserTwo + "' AND from_id = '" + UserOne + "' LIMIT 1") != null)
                {
                    return true;
                }
            }

            return false;
        }

        internal static Boolean FriendshipExists(UInt32 UserOne, UInt32 UserTwo)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                if (dbClient.ReadDataRow("SELECT user_one_id FROM messenger_friendships WHERE user_one_id = '" + UserOne + "' AND user_two_id = '" + UserTwo + "' LIMIT 1") != null)
                {
                    return true;
                }

                if (dbClient.ReadDataRow("SELECT user_one_id FROM messenger_friendships WHERE user_one_id = '" + UserTwo + "' AND user_two_id = '" + UserOne + "' LIMIT 1") != null)
                {
                    return true;
                }
            }

            return false;
        }

        internal void HandleAllRequests()
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("DELETE FROM messenger_requests WHERE to_id = '" + UserId + "'");
            }

            ClearRequests();
        }

        internal void HandleRequest(UInt32 FromId)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("userid", UserId);
                dbClient.AddParamWithValue("fromid", FromId);
                dbClient.ExecuteQuery("DELETE FROM messenger_requests WHERE to_id = @userid AND from_id = @fromid LIMIT 1");
            }

            if (GetRequest(FromId) != null)
            {
                mRequests.Remove(FromId);
            }
        }

        internal void CreateFriendship(UInt32 UserTwo)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("toid", UserTwo);
                dbClient.AddParamWithValue("userid", UserId);
                dbClient.ExecuteQuery("INSERT INTO messenger_friendships (user_one_id,user_two_id) VALUES (@userid,@toid)");
                dbClient.ExecuteQuery("INSERT INTO messenger_friendships (user_one_id,user_two_id) VALUES (@toid,@userid)");
            }

            OnNewFriendship(UserTwo);

            GameClient User = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserTwo);

            if (User != null && User.GetHabbo().GetMessenger() != null)
            {
                User.GetHabbo().GetMessenger().OnNewFriendship(UserId);
            }
        }

        internal void DestroyFriendship(UInt32 UserTwo)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("toid", UserTwo);
                dbClient.AddParamWithValue("userid", UserId);
                dbClient.ExecuteQuery("DELETE FROM messenger_friendships WHERE user_one_id = @toid AND user_two_id = @userid LIMIT 1");
                dbClient.ExecuteQuery("DELETE FROM messenger_friendships WHERE user_one_id = @userid AND user_two_id = @toid LIMIT 1");
            }

            OnDestroyFriendship(UserTwo);

            GameClient User = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserTwo);

            if (User != null && User.GetHabbo().GetMessenger() != null)
            {
                User.GetHabbo().GetMessenger().OnDestroyFriendship(UserId);
            }
        }

        internal void OnNewFriendship(UInt32 Friend)
        {
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataRow dRow = dbClient.ReadDataRow("SELECT username,motto,look,last_online FROM users WHERE id = '" + Friend + "'");


                MessengerBuddy Buddy = new MessengerBuddy(Friend, dRow["username"] as string, dRow["look"] as string, dRow["motto"] as string, dRow["last_online"] as string);
                Buddy.UpdateNeeded = true;

                mBuddies.Add(Buddy.Id, Buddy);

                ForceUpdate();
            }
        }

        internal void OnDestroyFriendship(UInt32 Friend)
        {
            mBuddies.Remove(Friend);
            //using (TimedLock.Lock(Buddies))
            //{
            //    foreach (MessengerBuddy Buddy in Buddies)
            //    {
            //        if (Buddy.Id == Friend)
            //        {
            //            Buddies.Remove(Buddy);
            //            break;
            //        }
            //    }
            //}

            GetClient().GetMessageHandler().GetResponse().Init(13);
            GetClient().GetMessageHandler().GetResponse().AppendInt32(0);
            GetClient().GetMessageHandler().GetResponse().AppendInt32(1);
            GetClient().GetMessageHandler().GetResponse().AppendInt32(-1);
            GetClient().GetMessageHandler().GetResponse().AppendUInt(Friend);
            GetClient().GetMessageHandler().SendResponse();
        }

        internal void RequestBuddy(string UserQuery)
        {
            DataRow Row = null;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("query", UserQuery.ToLower());
                Row = dbClient.ReadDataRow("SELECT id,block_newfriends FROM users WHERE username = @query LIMIT 1");
            }

            if (Row == null)
            {
                return;
            }
            else if (ButterflyEnvironment.EnumToBool(Row["block_newfriends"].ToString()))
            {
                GetClient().GetMessageHandler().GetResponse().Init(260);
                GetClient().GetMessageHandler().GetResponse().AppendInt32(39);
                GetClient().GetMessageHandler().GetResponse().AppendInt32(3);
                GetClient().GetMessageHandler().SendResponse();
                return;
            }

            uint ToId = (UInt32)Row["id"];

            if (RequestExists(UserId, ToId))
            {
                return;
            }

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("toid", ToId);
                dbClient.AddParamWithValue("userid", UserId);
                dbClient.ExecuteQuery("INSERT INTO messenger_requests (to_id,from_id) VALUES (@toid,@userid)");
            }

            GameClient ToUser = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(ToId);

            if (ToUser == null || ToUser.GetHabbo() == null)
            {
                return;
            }

            UInt32 RequestId = 0;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("toid", ToId);
                dbClient.AddParamWithValue("userid", UserId);
                RequestId = dbClient.ReadUInt32("SELECT id FROM messenger_requests WHERE to_id = @toid AND from_id = @userid ORDER BY id DESC LIMIT 1");
            }

            MessengerRequest Request = new MessengerRequest(ToId, UserId, ButterflyEnvironment.GetGame().GetClientManager().GetNameById(UserId));

            ToUser.GetHabbo().GetMessenger().OnNewRequest(RequestId, ToId, UserId);

            ServerMessage NewFriendNotif = new ServerMessage(132);
            Request.Serialize(NewFriendNotif);
            ToUser.SendMessage(NewFriendNotif);
        }

        internal void OnNewRequest(UInt32 Request, UInt32 ToId, UInt32 pUserId)
        {
            mRequests.Add(pUserId, new MessengerRequest(ToId, pUserId, ButterflyEnvironment.GetGame().GetClientManager().GetNameById(pUserId)));
        }

        internal void SendInstantMessage(UInt32 ToId, string Message)
        {
            if (!FriendshipExists(ToId, UserId))
            {
                DeliverInstantMessageError(6, ToId);
                return;
            }

            GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(ToId);

            if (Client == null || Client.GetHabbo().GetMessenger() == null)
            {
                DeliverInstantMessageError(5, ToId);
                return;
            }

            if (GetClient().GetHabbo().Muted)
            {
                DeliverInstantMessageError(4, ToId);
                return;
            }

            if (Client.GetHabbo().Muted)
            {
                DeliverInstantMessageError(3, ToId); // No return, as this is just a warning.
            }

            // todo: is busy??

            Client.GetHabbo().GetMessenger().DeliverInstantMessage(Message, UserId);
        }

        internal void DeliverInstantMessage(string Message, UInt32 ConversationId)
        {
            ServerMessage InstantMessage = new ServerMessage(134);
            InstantMessage.AppendUInt(ConversationId);
            InstantMessage.AppendString(Message);
            GetClient().SendMessage(InstantMessage);
        }

        internal void DeliverInstantMessageError(int ErrorId, UInt32 ConversationId)
        {
            /*
             * 3                =     Your friend is muted and cannot reply.
             * 4                =     Your message was not sent because you are muted.
             * 5                =     Your friend is not online.
             * 6                =     Receiver is not your friend anymore.
             * 7                =     Your friend is busy.
             * Anything else    =     Unknown im error <error no.>
             */

            ServerMessage Error = new ServerMessage(261);
            Error.AppendInt32(ErrorId);
            Error.AppendUInt(ConversationId);
            GetClient().SendMessage(Error);
        }

        internal ServerMessage SerializeFriends()
        {
            ServerMessage Friends = new ServerMessage(12);
            Friends.AppendInt32(600);
            Friends.AppendInt32(200);
            Friends.AppendInt32(600);
            Friends.AppendInt32(900);
            Friends.AppendBoolean(false);
            Friends.AppendInt32(mBuddies.Count);

            Hashtable ClonedBuddies = mBuddies.Clone() as Hashtable;

            foreach (MessengerBuddy Buddy in ClonedBuddies.Values)
            {
                Buddy.Serialize(Friends, false);
            }

            return Friends;
        }

        internal ServerMessage SerializeUpdates()
        {
            List<MessengerBuddy> UpdateBuddies = new List<MessengerBuddy>();
            int UpdateCount = 0;

            Hashtable ClonedBuddies = mBuddies.Clone() as Hashtable;

            foreach (MessengerBuddy Buddy in ClonedBuddies.Values)
            {

                if (Buddy.UpdateNeeded)
                {
                    UpdateCount++;
                    UpdateBuddies.Add(Buddy);
                    Buddy.UpdateNeeded = false;
                }
            }
            ClonedBuddies.Clear();

            ServerMessage Updates = new ServerMessage(13);
            Updates.AppendInt32(0);
            Updates.AppendInt32(UpdateCount);
            Updates.AppendInt32(0);

            foreach (MessengerBuddy Buddy in UpdateBuddies)
            {
                Buddy.Serialize(Updates, false);
                Updates.AppendBoolean(false);
            }

            return Updates;
        }

        internal ServerMessage SerializeRequests()
        {
            ServerMessage Reqs = new ServerMessage(314);
            Reqs.AppendInt32(mRequests.Count);
            Reqs.AppendInt32(mRequests.Count);

            Hashtable ClonedBuddies = mRequests.Clone() as Hashtable;

            foreach (MessengerRequest Request in ClonedBuddies.Values)
            {
                Request.Serialize(Reqs);
            }

            return Reqs;
        }

        internal ServerMessage PerformSearch(string SearchQuery)
        {
            DataTable Results = null;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("query", SearchQuery + "%");
                Results = dbClient.ReadDataTable("SELECT id FROM users WHERE username LIKE @query LIMIT 50");
            }

            List<DataRow> friendData = new List<DataRow>();
            List<DataRow> othersData = new List<DataRow>();

            if (Results != null)
            {
                foreach (DataRow Row in Results.Rows)
                {
                    if (FriendshipExists(UserId, (UInt32)Row["id"]))
                    {
                        friendData.Add(Row);

                        continue;
                    }

                    othersData.Add(Row);
                }
            }

            ServerMessage Search = new ServerMessage(435);

            Search.AppendInt32(friendData.Count);

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                foreach (DataRow Row in friendData)
                {
                    UInt32 id = (UInt32)Row["id"];
                    DataRow mRow = dbClient.ReadDataRow("SELECT username,motto,look,last_online FROM users WHERE id = '" + id + "'");
                    new MessengerBuddy(id, mRow["username"] as string, mRow["look"] as string, mRow["motto"] as string, mRow["last_online"] as string).Serialize(Search, true);
                }

                Search.AppendInt32(othersData.Count);

                foreach (DataRow Row in othersData)
                {
                    UInt32 id = (UInt32)Row["id"];
                    DataRow mRow = dbClient.ReadDataRow("SELECT username,motto,look,last_online FROM users WHERE id = '" + id + "'");
                    new MessengerBuddy(id, mRow["username"] as string, mRow["look"] as string, mRow["motto"] as string, mRow["last_online"] as string).Serialize(Search, true);
                }
            }

            return Search;
        }

        private GameClient GetClient()
        {
            return ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);
        }

        internal Hashtable GetBuddies()
        {
            return mBuddies.Clone() as Hashtable;
        }
    }
}