﻿
using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using System;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    partial class GameClientMessageHandler
    {
        //private const int HIGHEST_MESSAGE_ID = 4004;

        private GameClient Session;

        private ClientMessage Request;
        private ServerMessage Response;

        private delegate void RequestHandler();
        //private RequestHandler[] RequestHandlers;
        private Dictionary<uint, RequestHandler> RequestHandlers;

        internal GameClientMessageHandler(GameClient Session)
        {
            this.Session = Session;

            //RequestHandlers = new RequestHandler[HIGHEST_MESSAGE_ID];
            RequestHandlers = new Dictionary<uint, RequestHandler>();

            Response = new ServerMessage(0);
        }

        internal ServerMessage GetResponse()
        {
            return Response;
        }

        internal void Destroy()
        {
            //Array.Clear(RequestHandlers, 0, RequestHandlers.Length);
            RequestHandlers.Clear();
            //Session = null;
            RequestHandlers = null;

            //Request = null;
            //Response = null;
        }

        internal void HandleRequest(ClientMessage pRequest)
        {
            //Logging.WriteLine("[] --> [" + pRequest.Id + "] " + pRequest.Header);

            //if (pRequest.Id < 0 || pRequest.Id > HIGHEST_MESSAGE_ID)
            //{
            //    Logging.WriteLine("Warning - out of protocol request: " + pRequest.Header);
            //    return;
            //}

            if (!RequestHandlers.ContainsKey(pRequest.Id))
                return;

            this.Request = pRequest;
            RequestHandlers[pRequest.Id].Invoke();
            //this.Request = null;
        }

        internal void SendResponse()
        {
            if (Response != null)
                if (Response.Id > 0)
                    if (Session.GetConnection() != null)
                        Session.GetConnection().SendMessage(Response);
        }
    }
}
