﻿using System;
using System.Collections.Generic;
using System.Data;
using Butterfly.HabboHotel.Catalogs;
using Butterfly.HabboHotel.Items;
using Butterfly.Storage;
using Butterfly.HabboHotel.Users.Subscriptions;
using Butterfly.HabboHotel.Catalogs;

namespace Butterfly.Messages
{
    partial class GameClientMessageHandler
    {
        private void GetCatalogIndex()
        {
            Session.SendMessage(ButterflyEnvironment.GetGame().GetCatalog().GetIndexMessageForRank(Session.GetHabbo().Rank));
        }

        private void GetCatalogPage()
        {
            CatalogPage Page = ButterflyEnvironment.GetGame().GetCatalog().GetPage(Request.PopWiredInt32());

            if (Page == null || !Page.Enabled || !Page.Visible || Page.ComingSoon || Page.MinRank > Session.GetHabbo().Rank)
            {
                return;
            }

            if (Page.ClubOnly && !Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club"))
            {
                Session.SendNotif("This page is for Uber Club members only!");
                return;
            }

            Session.SendMessage(Page.GetMessage);

            if (Page.Layout == "recycler")
            {
                GetResponse().Init(507);
                GetResponse().AppendBoolean(true);
                GetResponse().AppendBoolean(false);
                SendResponse();

            }
            else if (Page.Layout == "club_buy")
            {
                #region HabboClub Packet
                ServerMessage HabboClubPage = new ServerMessage(625);
                // HABBO_CLUB_BASIC_3_MONTHSQKHHKQW[vGIPF
                Subscription Sub;
                DateTime NextMonth;
                DateTime NextThreeMonth;
                DateTime NextMonth2 = DateTime.Now.AddSeconds(60 * 60 * 24 * 31);
                DateTime NextThreeMonth2 = DateTime.Now.AddSeconds((60 * 60 * 24 * 31) * 3);
                int DaysLeft1;
                int DaysLeft2;
                if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club") || Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                {
                    string SId = "habbo_club";
                    if(Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                        SId = "habbo_vip";
                    Sub = Session.GetHabbo().GetSubscriptionManager().GetSubscription(SId);
                    Double Expire = Sub.ExpireTime;
                    Double TimeLeft = ButterflyEnvironment.GetUnixTimestamp() - Expire;
                    int TotalDaysLeft = (int)Math.Ceiling(TimeLeft / 86400);
                    DaysLeft1 = TotalDaysLeft + 31;
                    DaysLeft2 = TotalDaysLeft + 93;
                    NextMonth = DateTime.Now.AddSeconds(((60 * 60 * 24 * 31) + (60 * 60 * 24 * TotalDaysLeft)));
                    NextThreeMonth = DateTime.Now.AddSeconds((((60 * 60 * 24 * 31) * 3) + (60 * 60 * 24 * TotalDaysLeft)));
                }
                else
                {
                    Sub = null;
                    DaysLeft1 = 31;
                    DaysLeft2 = 93;
                    NextMonth = DateTime.Now.AddSeconds(60 * 60 * 24 * 31);
                    NextThreeMonth = DateTime.Now.AddSeconds((60 * 60 * 24 * 31) * 3);
                }
                using (DatabaseClient MySQL = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    DataRow SelectClubs = MySQL.ReadDataRow("SELECT * FROM catalog_items WHERE page_id = -1");
                    List<CatalogItem> Items = new List<HabboHotel.Catalogs.CatalogItem>();
                    foreach (DataRow Row in SelectClubs.Table.Rows)
                    {
                        Items.Add(new CatalogItem((uint)Row["id"], (string)Row["catalog_name"], (string)Row["item_ids"], (int)Row["cost_credits"], (int)Row["cost_pixels"], (int)Row["amount"], (int)Row["page_id"], (int)Row["cost_snow"], int.Parse(Row["hc_state"].ToString())));
                    }

                    if (!Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club") && !Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                    {
                        // BUY HC OR VIP+
                        // IqPAYmQHABBO_CLUB_BASIC_1_MONTH{2}SCHHISG[vGQASB[mQHABBO_CLUB_VIP_1_MONTH{2}QFHIISG[vGQASBXnQHABBO_CLUB_VIP_3_MONTHS{2}POHIKQW[vGSAPCZmQHABBO_CLUB_BASIC_3_MONTHS{2}QKHHKQW[vGSAPC
                        HabboClubPage.AppendInt32((Items.Count - 2));
                        foreach (CatalogItem Item in Items)
                        {
                            if (Item.Name.Contains("UPGRADE"))
                                continue;
                            HabboClubPage.AppendUInt(Item.Id); // ItemId
                            HabboClubPage.AppendStringWithBreak(Item.Name); // ItemName
                            HabboClubPage.AppendInt32(Item.CreditsCost); // Cost Credits
                            #region Bools
                            if (Item.Name.Contains("BASIC_1_MONTH"))
                                HabboClubPage.AppendString("HHI"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("VIP_1_MONTH"))
                                HabboClubPage.AppendString("HII"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("VIP_3_MONTHS"))
                                HabboClubPage.AppendString("HIK"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("BASIC_3_MONTHS"))
                                HabboClubPage.AppendString("HHK"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("UPGRADE_1"))
                                HabboClubPage.AppendString("IIH"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("UPGRADE_3"))
                                HabboClubPage.AppendString("IIK"); // Booleans, until to me D:!
                            #endregion
                            #region Date
                            if (Item.Name.Contains("1"))
                            {
                                HabboClubPage.AppendInt32(31); // Total days
                                HabboClubPage.AppendInt32(NextMonth.Year); // Year
                                HabboClubPage.AppendInt32(NextMonth.Month); // Month
                                HabboClubPage.AppendInt32(NextMonth.Day); // Day
                            }
                            else if (Item.Name.Contains("3"))
                            {
                                HabboClubPage.AppendInt32(93); // Total days
                                HabboClubPage.AppendInt32(NextThreeMonth.Year); // Year
                                HabboClubPage.AppendInt32(NextThreeMonth.Month); // Month
                                HabboClubPage.AppendInt32(NextThreeMonth.Day); // Day
                            }
                            #endregion
                        }
                    }
                    else if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club"))
                    {
                        // UPGRADE HC TO VIP
                        HabboClubPage.AppendInt32((Items.Count - 2));
                        foreach (CatalogItem Item in Items)
                        {
                            if (Item.Name.Contains("VIP"))
                                continue;
                            HabboClubPage.AppendUInt(Item.Id); // ItemId
                            HabboClubPage.AppendStringWithBreak(Item.Name); // ItemName
                            HabboClubPage.AppendInt32(Item.CreditsCost); // Cost Credits
                            #region Bools
                            if (Item.Name.Contains("BASIC_1_MONTH"))
                                HabboClubPage.AppendString("HHI"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("VIP_1_MONTH"))
                                HabboClubPage.AppendString("HII"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("VIP_3_MONTHS"))
                                HabboClubPage.AppendString("HIK"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("BASIC_3_MONTHS"))
                                HabboClubPage.AppendString("HHK"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("UPGRADE_1"))
                                HabboClubPage.AppendString("IIH"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("UPGRADE_3"))
                                HabboClubPage.AppendString("IIK"); // Booleans, until to me D:!
                            #endregion
                            #region Date
                            if (Item.Name.Contains("1"))
                            {
                                HabboClubPage.AppendInt32(31); // Total days
                                HabboClubPage.AppendInt32(NextMonth.Year); // Year
                                HabboClubPage.AppendInt32(NextMonth.Month); // Month
                                HabboClubPage.AppendInt32(NextMonth.Day); // Day
                            }
                            else if (Item.Name.Contains("3"))
                            {
                                HabboClubPage.AppendInt32(93); // Total days
                                HabboClubPage.AppendInt32(NextThreeMonth.Year); // Year
                                HabboClubPage.AppendInt32(NextThreeMonth.Month); // Month
                                HabboClubPage.AppendInt32(NextThreeMonth.Day); // Day
                            }
                            #endregion
                        }
                    }
                    else if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                    {
                        // UPGRADE VIP
                        // J[mQHABBO_CLUB_VIP_1_MONTH{2}QFHIIPf[vGQBRAXnQHABBO_CLUB_VIP_3_MONTHS{2}POHIKRu[vGSBSA{1}    
                        HabboClubPage.AppendInt32((Items.Count - 4));
                        foreach (CatalogItem Item in Items)
                        {
                            if (!Item.Name.Contains("VIP"))
                                continue;
                            HabboClubPage.AppendUInt(Item.Id); // ItemId
                            HabboClubPage.AppendStringWithBreak(Item.Name); // ItemName
                            HabboClubPage.AppendInt32(Item.CreditsCost); // Cost Credits
                            #region Bools
                            if (Item.Name.Contains("BASIC_1_MONTH"))
                                HabboClubPage.AppendString("HHI"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("VIP_1_MONTH"))
                                HabboClubPage.AppendString("HII"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("VIP_3_MONTHS"))
                                HabboClubPage.AppendString("HIK"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("BASIC_3_MONTHS"))
                                HabboClubPage.AppendString("HHK"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("UPGRADE_1"))
                                HabboClubPage.AppendString("IIH"); // Booleans, until to me D:!
                            else if (Item.Name.Contains("UPGRADE_3"))
                                HabboClubPage.AppendString("IIK"); // Booleans, until to me D:!
                            #endregion
                            #region Date
                            if (Item.Name.Contains("1"))
                            {
                                HabboClubPage.AppendInt32(31); // Total days
                                HabboClubPage.AppendInt32(NextMonth.Year); // Year
                                HabboClubPage.AppendInt32(NextMonth.Month); // Month
                                HabboClubPage.AppendInt32(NextMonth.Day); // Day
                            }
                            else if (Item.Name.Contains("3"))
                            {
                                HabboClubPage.AppendInt32(93); // Total days
                                HabboClubPage.AppendInt32(NextThreeMonth.Year); // Year
                                HabboClubPage.AppendInt32(NextThreeMonth.Month); // Month
                                HabboClubPage.AppendInt32(NextThreeMonth.Day); // Day
                            }
                            #endregion
                        }
                    }
                }
                Session.SendMessage(HabboClubPage);
                #endregion
            }
            else if (Page.Layout == "club_gifts")
            {
                #region Gift Packet
                // IoISAPF[dQhc2_sofa{2}IHHIs{2}XXL{2}IMZdQhc3_sofa{2}IHHIs{2}[WL{2}IM[eQhc2_sofatbl{2}IHHIs{2}XYL{2}IMZfQhc3_table{2}IHHIs{2}[YL{2}IMXbQhc2_biglamp{2}IHHIs{2}YUL{2}IMY^Qhc3_bard{2}IHHIs{2}ZQL{2}IMX_Qhc2_cart{2}IHHIs{2}YRL{2}IMXaQhc3_light{2}IHHIs{2}YTL{2}IMXdQhc2_vase{2}IHHIs{2}YWL{2}IMYbQhc3_dc{2}IHHIs{2}ZUL{2}IMZ]Qhc2_divider{2}IHHIs{2}[PL{2}IMYfQhc3_shelf{2}IHHIs{2}ZYL{2}IMZ_Qhc2_carpet{2}IHHIs{2}[RL{2}IMYdQhc3_stool{2}IHHIs{2}ZWL{2}IMXeQhc2_dvn{2}IHHIs{2}YXL{2}IMY]Qhc3_divider{2}IHHIs{2}ZPL{2}IM[cQhc2_coffee{2}IHHIs{2}XWL{2}IMY`Qhc3_hugelamp{2}IHHIs{2}ZSL{2}IM[bQhc2_frplc{2}IHHIs{2}XVL{2}IMXhQhc3_walldeco{2}IHHIi{2}YP{2}IM[_Qhc2_barchair{2}IHHIs{2}XSL{2}IMXrQhc3_stereo{2}IHHIs{2}[\L{2}IMX`Qhc2_armchair{2}IHHIs{2}YSL{2}IMYoQhc3_vase{2}IHHIs{2}XZL{2}IMPF[dQHIIZdQIII[eQHPHIZfQIPHIXbQHSOIY^QISOIX_QHRWIXaQIRWIXdQHQ_IYbQIQ_IZ]QHPgIYfQIPgIZ_QHSnIYdQISnIXeQHRvIY]QIRvI[cQHQ~IY`QIQ~I[bQHXFAIXhQIXFAI[_QH[MAIXrQI[MAIX`QHZUAIYoQIZUAH{1}
                ServerMessage ClubPage = new ServerMessage(623);
                int Months = 0;
                int TotalDaysLeft = 0;
                if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club") || Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                {
                    string Club = "habbo_club";
                    if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                        Club = "habbo_vip";
                    Subscription HabboClub = Session.GetHabbo().GetSubscriptionManager().GetSubscription(Club);
                    Double Initial = HabboClub.InitialTime;
                    Double TimeLeft = ButterflyEnvironment.GetUnixTimestamp() - Initial;
                    TotalDaysLeft = (int)Math.Ceiling(TimeLeft / 86400);
                    int MonthsLeft = TotalDaysLeft / 31;
                    Months = (MonthsLeft - HabboClub.Gifts) + HabboClub.Days;
                }
                ClubPage.AppendInt32(-1);
                ClubPage.AppendInt32(Months);
                // PM [dQ
                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    DataRow GetGifts = dbClient.ReadDataRow("SELECT * FROM club_gifts");
                    ClubPage.AppendInt32(GetGifts.Table.Rows.Count); // Count Items
                    foreach (DataRow Data in GetGifts.Table.Rows)
                    {
                        ClubPage.AppendInt32((int)Data["id"]); // Item Id (no important what)
                        ClubPage.AppendStringWithBreak(Data["name"].ToString()); // Item Name
                        ClubPage.AppendBoolean(true); // some value
                        ClubPage.AppendBoolean(false); // some value
                        ClubPage.AppendBoolean(false); // some value
                        ClubPage.AppendBoolean(true); // some value
                        ClubPage.AppendStringWithBreak(Data["type"].ToString()); // Type
                        ClubPage.AppendInt32((int)Data["spriteid"]); // SpriteID
                        ClubPage.AppendStringWithBreak(""); // Char
                        ClubPage.AppendInt32(1); // Boolean true (no important)
                        ClubPage.AppendInt32(-1); // Negative M Value
                        ClubPage.AppendInt32((int.Parse(Data["is_vip"].ToString()))); // Is VIP Item?
                    }
                    // Sistem of evaluate
                    ClubPage.AppendInt32(GetGifts.Table.Rows.Count); // Count Again
                    foreach (DataRow Data in GetGifts.Table.Rows)
                    {
                        ClubPage.AppendInt32((int)Data["id"]); // Item Id (no important what)
                        ClubPage.AppendInt32(int.Parse(Data["is_vip"].ToString())); // Is VIP Item?
                        ClubPage.AppendInt32((int)Data["days"]); // Days to get
                        if (TotalDaysLeft >= (int)Data["days"])
                        {
                            if (int.Parse(Data["is_vip"].ToString()) == 1 && Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                                ClubPage.AppendBoolean(true); // Enable?
                            else if (int.Parse(Data["is_vip"].ToString()) == 0 && Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club") || int.Parse(Data["is_vip"].ToString()) == 0 && Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                                ClubPage.AppendBoolean(true); // Enable?
                            else
                                ClubPage.AppendBoolean(false); // Enable?
                        }
                        else
                            ClubPage.AppendBoolean(false); // Enable?
                    }
                }
                Session.SendMessage(ClubPage);
                #endregion
            }
        }

        private void RedeemVoucher()
        {
            VoucherHandler.TryRedeemVoucher(Session, Request.PopFixedString());
        }

        private void HandlePurchase()
        {
            int PageId = Request.PopWiredInt32();
            uint ItemId = Request.PopWiredUInt();
            string ExtraData = Request.PopFixedString();

            ButterflyEnvironment.GetGame().GetCatalog().HandlePurchase(Session, PageId, ItemId, ExtraData, false, "", "");
        }

        private void PurchaseGift()
        {
            int PageId = Request.PopWiredInt32();
            uint ItemId = Request.PopWiredUInt();
            string ExtraData = Request.PopFixedString();
            string GiftUser = ButterflyEnvironment.FilterInjectionChars(Request.PopFixedString());
            string GiftMessage = ButterflyEnvironment.FilterInjectionChars(Request.PopFixedString());

            ButterflyEnvironment.GetGame().GetCatalog().HandlePurchase(Session, PageId, ItemId, ExtraData, true, GiftUser, GiftMessage);
        }

        private void GetRecyclerRewards()
        {
            // GzQAQAXtGIsZJKPAPrIsXLKKPJKsY}JsXBKsX~JJPASCsX|JiXBPsZAKs[|JiYBPsZ}JsXAKsYAKsX}JsY|JsY~Js[{JiZAPs[JsZBKIIRAsX@KsYBKsZJs[@Ks[~JsZ|J

            GetResponse().Init(506);
            GetResponse().AppendInt32(5);

            for (uint i = 5; i >= 1; i--)
            {
                GetResponse().AppendUInt(i);

                if (i <= 1)
                {
                    GetResponse().AppendInt32(0);
                }
                else if (i == 2)
                {
                    GetResponse().AppendInt32(4);
                }
                else if (i == 3)
                {
                    GetResponse().AppendInt32(40);
                }
                else if (i == 4)
                {
                    GetResponse().AppendInt32(200);
                }
                else if (i >= 5)
                {
                    GetResponse().AppendInt32(2000);
                }

                List<EcotronReward> Rewards = ButterflyEnvironment.GetGame().GetCatalog().GetEcotronRewardsForLevel(i);

                GetResponse().AppendInt32(Rewards.Count);

                foreach (EcotronReward Reward in Rewards)
                {
                    GetResponse().AppendStringWithBreak(Reward.GetBaseItem().Type.ToString().ToLower());
                    GetResponse().AppendUInt(Reward.DisplayId);
                }
            }

            SendResponse();
        }

        private void CanGift()
        {
            uint Id = Request.PopWiredUInt();

            CatalogItem Item = ButterflyEnvironment.GetGame().GetCatalog().FindItem(Id);

            if (Item == null)
            {
                return;
            }

            GetResponse().Init(622);
            GetResponse().AppendUInt(Item.Id);
            GetResponse().AppendBoolean(Item.GetBaseItem().AllowGift);
            SendResponse();
        }

        private void GetCataData1()
        {
            GetResponse().Init(612);
            //  1 1 1 5 1 10000 48 7
            GetResponse().AppendInt32(1);
            GetResponse().AppendInt32(1);
            GetResponse().AppendInt32(1);
            GetResponse().AppendInt32(5);
            GetResponse().AppendInt32(1);
            GetResponse().AppendInt32(10000);
            GetResponse().AppendInt32(48);
            GetResponse().AppendInt32(7);
            SendResponse();
        }

        private void GetCataData2()
        {
            // Il
            GetResponse().Init(620);
            GetResponse().AppendInt32(1);
            GetResponse().AppendInt32(1);
            GetResponse().AppendInt32(10);
            GetResponse().AppendInt32(3064);
            GetResponse().AppendInt32(3065);
            GetResponse().AppendInt32(3066);
            GetResponse().AppendInt32(3067);
            GetResponse().AppendInt32(3068);
            GetResponse().AppendInt32(3069);
            GetResponse().AppendInt32(3070);
            GetResponse().AppendInt32(3071);
            GetResponse().AppendInt32(3072);
            GetResponse().AppendInt32(3073);
            GetResponse().AppendString("SAHIJKPAQARASBHIJKPAQARASAPBQBRB");
            SendResponse();
        }

        private void MarketplaceCanSell()
        {
            GetResponse().Init(611);
            GetResponse().AppendBoolean(true);
            GetResponse().AppendInt32(99999);
            SendResponse();
        }

        private void MarketplacePostItem()
        {
            if (Session.GetHabbo().GetInventoryComponent() == null)
            {
                return;
            }

            int sellingPrice = Request.PopWiredInt32();
            int junk = Request.PopWiredInt32();
            uint itemId = Request.PopWiredUInt();

            UserItem Item = Session.GetHabbo().GetInventoryComponent().GetItem(itemId);

            if (Item == null || !Item.GetBaseItem().AllowTrade)
            {
                return;
            }

            Marketplace.SellItem(Session, Item.Id, sellingPrice);
        }

        private void MarketplaceGetOwnOffers()
        {
            Session.SendMessage(Marketplace.SerializeOwnOffers(Session.GetHabbo().Id));
        }

        private void MarketplaceTakeBack()
        {
            uint ItemId = Request.PopWiredUInt();
            DataRow Row = null;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                Row = dbClient.ReadDataRow("SELECT item_id, user_id, extra_data, offer_id state FROM catalog_marketplace_offers WHERE offer_id = '" + ItemId + "' LIMIT 1");
            }

            if (Row == null || (UInt32)Row["user_id"] != Session.GetHabbo().Id || (UInt32)Row["state"] != 1)
            {
                return;
            }

            Item Item = ButterflyEnvironment.GetGame().GetItemManager().GetItem((UInt32)Row["item_id"]);

            if (Item == null)
            {
                return;
            }

            ButterflyEnvironment.GetGame().GetCatalog().DeliverItems(Session, Item, 1, (String)Row["extra_data"]);

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("DELETE FROM catalog_marketplace_offers WHERE offer_id = '" + ItemId + "' LIMIT 1");
            }

            GetResponse().Init(614);
            GetResponse().AppendUInt((UInt32)Row["offer_id"]);
            GetResponse().AppendBoolean(true);
            SendResponse();
        }

        private void MarketplaceClaimCredits()
        {
            DataTable Results = null;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                Results = dbClient.ReadDataTable("SELECT asking_price FROM catalog_marketplace_offers WHERE user_id = '" + Session.GetHabbo().Id + "' AND state = '2'");
            }

            if (Results == null)
            {
                return;
            }

            int Profit = 0;

            foreach (DataRow Row in Results.Rows)
            {
                Profit += (int)Row["asking_price"];
            }

            if (Profit >= 1)
            {
                Session.GetHabbo().Credits += Profit;
                Session.GetHabbo().UpdateCreditsBalance();
            }

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("DELETE FROM catalog_marketplace_offers WHERE user_id = '" + Session.GetHabbo().Id + "' AND state = '2'");
            }
        }

        private void MarketplaceGetOffers()
        {
            int MinPrice = Request.PopWiredInt32();
            int MaxPrice = Request.PopWiredInt32();
            string SearchQuery = Request.PopFixedString();
            int FilterMode = Request.PopWiredInt32();

            Session.SendMessage(Marketplace.SerializeOffers(MinPrice, MaxPrice, SearchQuery, FilterMode));
        }

        private void MarketplacePurchase()
        {
            uint ItemId = Request.PopWiredUInt();
            DataRow Row = null;

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                Row = dbClient.ReadDataRow("SELECT state, timestamp, total_price, extra_data, item_id FROM catalog_marketplace_offers WHERE offer_id = '" + ItemId + "' LIMIT 1");
            }

            if (Row == null || (string)Row["state"] != "1" || (double)Row["timestamp"] <= Marketplace.FormatTimestamp())
            {
                Session.SendNotif("Sorry, this offer has expired.");
                return;
            }

            Item Item = ButterflyEnvironment.GetGame().GetItemManager().GetItem((UInt32)Row["item_id"]);

            if (Item == null)
            {
                return;
            }

            if ((int)Row["total_price"] >= 1)
            {
                Session.GetHabbo().Credits -= (int)Row["total_price"];
                Session.GetHabbo().UpdateCreditsBalance();
            }

            ButterflyEnvironment.GetGame().GetCatalog().DeliverItems(Session, Item, 1, (String)Row["extra_data"]);

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("UPDATE catalog_marketplace_offers SET state = '2' WHERE offer_id = '" + ItemId + "' LIMIT 1");
            }

            Session.GetMessageHandler().GetResponse().Init(67);
            Session.GetMessageHandler().GetResponse().AppendUInt(Item.ItemId);
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak(Item.Name);
            Session.GetMessageHandler().GetResponse().AppendInt32(0);
            Session.GetMessageHandler().GetResponse().AppendInt32(0);
            Session.GetMessageHandler().GetResponse().AppendInt32(1);
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak(Item.Type.ToString());
            Session.GetMessageHandler().GetResponse().AppendInt32(Item.SpriteId);
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak("");
            Session.GetMessageHandler().GetResponse().AppendInt32(1);
            Session.GetMessageHandler().GetResponse().AppendInt32(-1);
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak("");
            Session.GetMessageHandler().SendResponse();

            Session.SendMessage(Marketplace.SerializeOffers(-1, -1, "", 1));
        }

        private void CheckPetName()
        {
            Session.GetMessageHandler().GetResponse().Init(36);
            Session.GetMessageHandler().GetResponse().AppendInt32(Catalog.CheckPetName(Request.PopFixedString()) ? 0 : 2);
            Session.GetMessageHandler().SendResponse();
        }

        private void PurchaseClubGift()
        {
            try
            {
                if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip") || Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club"))
                {
                    string SId = "habbo_club";
                    if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
                        SId = "habbo_vip";
                    Subscription Subs = Session.GetHabbo().GetSubscriptionManager().GetSubscription(SId);
                    int ActualGifts = Subs.Gifts - 1;
                    if (ActualGifts != -1)
                    {
                        using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                        {
                            string GiftName = Request.ToString().Substring(4);
                            Console.WriteLine(GiftName);
                            // Filter for noobs
                            if (!GiftName.Contains("hc2") && !GiftName.Contains("hc3"))
                                return;
                            int SpriteId = dbClient.ReadInt32("SELECT spriteid FROM club_gifts WHERE name = '" + GiftName + "'");
                            int FurniId = dbClient.ReadInt32("SELECT id FROM furniture WHERE sprite_id = '" + SpriteId + "'");
                            dbClient.ExecuteQuery("INSERT INTO user_items (id,user_id,base_item,extra_data) VALUES (NULL, '" + Session.GetHabbo().Id + "', '" + FurniId + "', '');");

                            Session.GetMessageHandler().GetResponse().Init(140);
                            Session.GetMessageHandler().SendResponse();

                            dbClient.ExecuteQuery("UPDATE user_subscriptions SET usedgifts = '" + ActualGifts + "' WHERE user_id = '" + Session.GetHabbo().Id + "'");
                            if (Subs.Days >= 1)
                            {
                                dbClient.ExecuteQuery("UPDATE users_subscriptions SET useddays = '0' WHERE user_id = '" + Session.GetHabbo().Id + "'");
                            }
                        }
                    }
                }
            }
            catch { }

        }

        internal void RegisterCatalog()
        {
            RequestHandlers.Add(101, new RequestHandler(GetCatalogIndex));
            RequestHandlers.Add(102,new RequestHandler(GetCatalogPage));
            RequestHandlers.Add(129,new RequestHandler(RedeemVoucher));
            RequestHandlers.Add(100,new RequestHandler(HandlePurchase));
            RequestHandlers.Add(472,new RequestHandler(PurchaseGift));
            RequestHandlers.Add(475,new RequestHandler(PurchaseClubGift));
            RequestHandlers.Add(412,new RequestHandler(GetRecyclerRewards));
            RequestHandlers.Add(3030,new RequestHandler(CanGift));
            RequestHandlers.Add(3011,new RequestHandler(GetCataData1));
            RequestHandlers.Add(473,new RequestHandler(GetCataData2));
            RequestHandlers.Add(3012,new RequestHandler(MarketplaceCanSell));
            RequestHandlers.Add(3010,new RequestHandler(MarketplacePostItem));
            RequestHandlers.Add(3019,new RequestHandler(MarketplaceGetOwnOffers));
            RequestHandlers.Add(3015,new RequestHandler(MarketplaceTakeBack));
            RequestHandlers.Add(3016,new RequestHandler(MarketplaceClaimCredits));
            RequestHandlers.Add(3018,new RequestHandler(MarketplaceGetOffers));
            RequestHandlers.Add(3014,new RequestHandler(MarketplacePurchase));
            RequestHandlers.Add(42, new RequestHandler(CheckPetName));
        }
    }
}
