﻿
using Butterfly.HabboHotel.Navigators;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Storage;

namespace Butterfly.Messages
{
    partial class GameClientMessageHandler
    {
        private void AddFavorite()
        {
            uint Id = Request.PopWiredUInt();

            RoomData Data = ButterflyEnvironment.GetGame().GetRoomManager().GenerateRoomData(Id);

            if (Data == null || Session.GetHabbo().FavoriteRooms.Count >= 30 || Session.GetHabbo().FavoriteRooms.Contains(Id) || Data.Type == "public")
            {
                GetResponse().Init(33);
                GetResponse().AppendInt32(-9001);
                SendResponse();

                return;
            }

            GetResponse().Init(459);
            GetResponse().AppendUInt(Id);
            GetResponse().AppendBoolean(true);
            SendResponse();

            Session.GetHabbo().FavoriteRooms.Add(Id);

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("INSERT INTO user_favorites (user_id,room_id) VALUES ('" + Session.GetHabbo().Id + "','" + Id + "')");
            }
        }

        private void RemoveFavorite()
        {
            uint Id = Request.PopWiredUInt();

            Session.GetHabbo().FavoriteRooms.Remove(Id);

            GetResponse().Init(459);
            GetResponse().AppendUInt(Id);
            GetResponse().AppendBoolean(false);
            SendResponse();

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("DELETE FROM user_favorites WHERE user_id = '" + Session.GetHabbo().Id + "' AND room_id = '" + Id + "' LIMIT 1");
            }
        }

        private void GoToHotelView()
        {
            if (Session.GetHabbo().InRoom)
            {
                ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(Session.GetHabbo().CurrentRoomId).RemoveUserFromRoom(Session, true, false);
            }
        }

        private void GetFlatCats()
        {
            Session.SendMessage(ButterflyEnvironment.GetGame().GetNavigator().SerializeFlatCategories());
        }

        private void EnterInquiredRoom()
        {
            // ???????????????????????????????
            // I like cake :D
        }

        private void GetPubs()
        {
            Session.SendMessage(ButterflyEnvironment.GetGame().GetNavigator().SerializePublicRooms());
        }

        private void GetRoomInfo()
        {
            uint RoomId = Request.PopWiredUInt();
            bool unk = Request.PopWiredBoolean();
            bool unk2 = Request.PopWiredBoolean();

            RoomData Data = ButterflyEnvironment.GetGame().GetRoomManager().GenerateRoomData(RoomId);

            if (Data == null)
            {
                return;
            }

            GetResponse().Init(454);
            GetResponse().AppendInt32(0);
            Data.Serialize(GetResponse(), false);
            SendResponse();
        }

        private void GetPopularRooms()
        {
            Session.GetConnection().SendData(Navigator.SerializeRoomListing(Session, Request.PopFixedInt32()));
        }


        private void GetHighRatedRooms()
        {
            Session.GetConnection().SendData(Navigator.SerializeRoomListing(Session, -2));
        }

        private void GetFriendsRooms()
        {
            //Session.SendMessage(UberEnvironment.GetGame().GetNavigator().SerializeRoomListing(Session, -4));
            Session.SendMessage(Navigator.GetDynamicNavigatorPacket(Session, -4));
        }

        private void GetRoomsWithFriends()
        {
            //Session.SendMessage(UberEnvironment.GetGame().GetNavigator().SerializeRoomListing(Session, -5));
            Session.SendMessage(Navigator.GetDynamicNavigatorPacket(Session, -5));
        }

        private void GetOwnRooms()
        {
            //Session.SendMessage(UberEnvironment.GetGame().GetNavigator().SerializeRoomListing(Session, -3));
            Session.SendMessage(Navigator.GetDynamicNavigatorPacket(Session, -3));
        }

        private void GetFavoriteRooms()
        {
            Session.SendMessage(Navigator.SerializeFavoriteRooms(Session));
        }

        private void GetRecentRooms()
        {
            Session.SendMessage(Navigator.SerializeRecentRooms(Session));
        }

        private void GetEvents()
        {
            int Category = int.Parse(Request.PopFixedString());

            Session.SendMessage(Navigator.SerializeEventListing(Category));
        }

        private void GetPopularTags()
        {
            Session.SendMessage(Navigator.SerializePopularRoomTags());
        }

        private void PerformSearch()
        {
            Session.SendMessage(Navigator.SerializeSearchResults(Request.PopFixedString()));
        }

        private void PerformSearch2()
        {
            int junk = Request.PopWiredInt32();
            Session.SendMessage(Navigator.SerializeSearchResults(Request.PopFixedString()));
        }

        internal void RegisterNavigator()
        {
            RequestHandlers.Add(19, new RequestHandler(AddFavorite));
            RequestHandlers.Add(20, new RequestHandler(RemoveFavorite));
            RequestHandlers.Add(53, new RequestHandler(GoToHotelView));
            RequestHandlers.Add(151, new RequestHandler(GetFlatCats));
            RequestHandlers.Add(233, new RequestHandler(EnterInquiredRoom));
            //RequestHandlers.Add(380, new RequestHandler(GetPubs));
            RequestHandlers.Add(385, new RequestHandler(GetRoomInfo));
            RequestHandlers.Add(430, new RequestHandler(GetPopularRooms));
            RequestHandlers.Add(431, new RequestHandler(GetHighRatedRooms));
            RequestHandlers.Add(432, new RequestHandler(GetFriendsRooms));
            RequestHandlers.Add(433, new RequestHandler(GetRoomsWithFriends));
            RequestHandlers.Add(434, new RequestHandler(GetOwnRooms));
            RequestHandlers.Add(435, new RequestHandler(GetFavoriteRooms));
            RequestHandlers.Add(436, new RequestHandler(GetRecentRooms));
            RequestHandlers.Add(439, new RequestHandler(GetEvents));
            RequestHandlers.Add(382, new RequestHandler(GetPopularTags));
            RequestHandlers.Add(437, new RequestHandler(PerformSearch));
            RequestHandlers.Add(438, new RequestHandler(PerformSearch2));
        }
    }
}
