﻿using System;
using System.Data;
using Butterfly.HabboHotel.Misc;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users.Subscriptions;
using Butterfly.HabboHotel.Users.Badges;
using Butterfly.Storage;

namespace Butterfly.Messages
{
    partial class GameClientMessageHandler
    {
        private void GetUserInfo()
        {
            GetResponse().Init(5);
            GetResponse().AppendStringWithBreak(Session.GetHabbo().Id.ToString());
            GetResponse().AppendStringWithBreak(Session.GetHabbo().Username);
            GetResponse().AppendStringWithBreak(Session.GetHabbo().Look);
            GetResponse().AppendStringWithBreak(Session.GetHabbo().Gender.ToUpper());
            GetResponse().AppendStringWithBreak(Session.GetHabbo().Motto);
            GetResponse().AppendStringWithBreak(Session.GetHabbo().RealName);
            GetResponse().AppendInt32(0);
            GetResponse().AppendStringWithBreak("");
            GetResponse().AppendInt32(0);
            GetResponse().AppendInt32(0);
            GetResponse().AppendInt32(Session.GetHabbo().Respect);
            GetResponse().AppendInt32(Session.GetHabbo().DailyRespectPoints); // respect to give away
            GetResponse().AppendInt32(Session.GetHabbo().DailyPetRespectPoints);
            SendResponse();
        }

        private void GetBalance()
        {
            Session.GetHabbo().UpdateCreditsBalance();
            Session.GetHabbo().UpdateActivityPointsBalance(false);
        }

        internal void GetSubscriptionData()
        {
            Subscription Sub;
            ServerMessage Update = new ServerMessage(7);
            Update.AppendStringWithBreak("club_habbo");
            if (!Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club") && !Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
            {
                for (int i = 0; i < 8; i++)
                {
                    Update.AppendBoolean(false);
                }
                Update.AppendInt32(1);
                Update.AppendInt32(20);
                Update.AppendInt32(15);
            }
            else if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_club"))
            {
                // IdIIIQAIXDgPLSA
                // @Gclub_habbo{2}SGHHJIHIHHHH
                // @G - club_habbo - char2 - 31 - 0 - 0 - 2 - 1 - 0 - 1 - 0 - 0 - 0 - 0
                Sub = Session.GetHabbo().GetSubscriptionManager().GetSubscription("habbo_club");
                Double Expire = Sub.ExpireTime;
                Double TimeLeft = Expire - ButterflyEnvironment.GetUnixTimestamp();
                int TotalDaysLeft = (int)Math.Ceiling(TimeLeft / 86400);
                int MonthsLeft;
                if (TotalDaysLeft <= 31)
                    MonthsLeft = 0;
                else
                    MonthsLeft = TotalDaysLeft / 31;
                Double Initial = Sub.InitialTime;
                Double TimeLeft2 = ButterflyEnvironment.GetUnixTimestamp() - Initial;
                int TotalDaysLeft2 = (int)Math.Ceiling(TimeLeft2 / 86400);
                int MonthsLeft2 = TotalDaysLeft2 / 31;
                if (TotalDaysLeft - (MonthsLeft * 31) == 0)
                {
                    MonthsLeft = MonthsLeft - 1;
                }
                Update.AppendInt32(TotalDaysLeft - (MonthsLeft * 31)); // Days Of Subcription
                Update.AppendInt32(1); // ? Of Subcription
                Update.AppendInt32(MonthsLeft); // Months Of Subscription
                Update.AppendBoolean(true); // Boolean Of Subscription
                Update.AppendBoolean(true); // Boolean Of Subscription
                Update.AppendBoolean(false); // Type Of Subscription (true = VIP)/(false = HC)
                Update.AppendInt32(TotalDaysLeft2); // Days Of HC
                Update.AppendInt32(0); // Days Of VIP
                // And the Subscription Alert
                Update.AppendBoolean(false); // Alert Active?
                Update.AppendInt32(15); // Initial Price
                Update.AppendInt32(10); // New Price
            }
            else if (Session.GetHabbo().GetSubscriptionManager().HasSubscription("habbo_vip"))
            {
                // HC:  #SG : 31 | #H : 0 | H : 0 | #J : 2 | #I : 1 | #H : 0 | #I : 1 | #H : 0 | #H : 0 | #H : 0 | #H : 0
                // VIP: #QF : 25 | #QD : 17 | #K : 3 | #I : 1 | #I : 1 | #I : 1 | #Rn : 186 | #XWA : 348 | #H : 0 | #H : 0 | #H : 0 | 
                // Fin: Days     |   ??   | Months ||   ??   |   ??   |   ??   | HC Days  | VIP Days | Alert | Price | LOL | Bool ||
                Sub = Session.GetHabbo().GetSubscriptionManager().GetSubscription("habbo_vip");
                Double Expire = Sub.ExpireTime;
                Double TimeLeft = Expire - ButterflyEnvironment.GetUnixTimestamp();
                int TotalDaysLeft = (int)Math.Ceiling(TimeLeft / 86400);
                int MonthsLeft = TotalDaysLeft / 31;
                Double Initial = Sub.InitialTime;
                Double TimeLeft2 = ButterflyEnvironment.GetUnixTimestamp() - Initial;
                int TotalDaysLeft2 = (int)Math.Ceiling(TimeLeft2 / 86400);
                if (TotalDaysLeft - (MonthsLeft * 31) == 0)
                {
                    MonthsLeft = MonthsLeft - 1;
                }
                Update.AppendInt32(TotalDaysLeft - (MonthsLeft * 31)); // Days Of Subcription
                Update.AppendInt32(1); // ? Of Subcription
                Update.AppendInt32(MonthsLeft); // Months Of Subscription
                Update.AppendBoolean(true); // Boolean Of Subscription
                Update.AppendBoolean(true); // Boolean Of Subscription
                Update.AppendBoolean(true); // Type Of Subscription (true = VIP)/(false = HC)
                Update.AppendInt32(0); // Days Of HC
                Update.AppendInt32(TotalDaysLeft2); // Days Of VIP
                // And the Subscription Alert
                Update.AppendBoolean(false); // Alert Active?
                Update.AppendInt32(15); // Initial Price
                Update.AppendInt32(10); // New Price
            }

            // ROPQHHH
            Session.SendMessage(Update);

        }

        private void GetBadges()
        {
            Session.SendMessage(Session.GetHabbo().GetBadgeComponent().Serialize());
        }

        private void UpdateBadges()
        {
            Session.GetHabbo().GetBadgeComponent().ResetSlots();

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.ExecuteQuery("UPDATE user_badges SET badge_slot = '0' WHERE user_id = '" + Session.GetHabbo().Id + "'");
            }

            while (Request.RemainingLength > 0)
            {
                int Slot = Request.PopWiredInt32();
                string Badge = Request.PopFixedString();

                if (Badge.Length == 0)
                {
                    continue;
                }

                if (!Session.GetHabbo().GetBadgeComponent().HasBadge(Badge) || Slot < 1 || Slot > 5)
                {
                    return;
                }

                Session.GetHabbo().GetBadgeComponent().GetBadge(Badge).Slot = Slot;

                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.AddParamWithValue("slotid", Slot);
                    dbClient.AddParamWithValue("badge", Badge);
                    dbClient.AddParamWithValue("userid", Session.GetHabbo().Id);
                    dbClient.ExecuteQuery("UPDATE user_badges SET badge_slot = @slotid WHERE badge_id = @badge AND user_id = @userid LIMIT 1");
                }
            }

            ServerMessage Message = new ServerMessage(228);
            Message.AppendUInt(Session.GetHabbo().Id);
            Message.AppendInt32(Session.GetHabbo().GetBadgeComponent().EquippedCount);

            foreach (Badge Badge in Session.GetHabbo().GetBadgeComponent().BadgeList)
            {
                if (Badge.Slot <= 0)
                {
                    continue;
                }

                Message.AppendInt32(Badge.Slot);
                Message.AppendStringWithBreak(Badge.Code);
            }

            if (Session.GetHabbo().InRoom && ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(Session.GetHabbo().CurrentRoomId) != null)
            {
                ButterflyEnvironment.GetGame().GetRoomManager().GetRoom(Session.GetHabbo().CurrentRoomId).SendMessage(Message);
            }
            else
            {
                Session.SendMessage(Message);
            }
        }

        private void GetAchievements()
        {
            Session.SendMessage(ButterflyEnvironment.GetGame().GetAchievementManager().SerializeAchievementList(Session));
        }

        private void ChangeLook()
        {
            if (Session.GetHabbo().MutantPenalty)
            {
                Session.SendNotif("Because of a penalty or restriction on your account, you are not allowed to change your look.");
                return;
            }

            string Gender = Request.PopFixedString().ToUpper();
            string Look = ButterflyEnvironment.FilterInjectionChars(Request.PopFixedString());

            if (!AntiMutant.ValidateLook(Look, Gender))
            {
                return;
            }

            Session.GetHabbo().Look = Look;
            Session.GetHabbo().Gender = Gender.ToLower();

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("look", Look);
                dbClient.AddParamWithValue("gender", Gender);
                dbClient.ExecuteQuery("UPDATE users SET look = @look, gender = @gender WHERE id = '" + Session.GetHabbo().Id + "' LIMIT 1;");
            }

            Session.GetMessageHandler().GetResponse().Init(266);
            Session.GetMessageHandler().GetResponse().AppendInt32(-1);
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak(Session.GetHabbo().Look);
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak(Session.GetHabbo().Gender.ToLower());
            Session.GetMessageHandler().GetResponse().AppendStringWithBreak(Session.GetHabbo().Motto);
            Session.GetMessageHandler().SendResponse();

            if (Session.GetHabbo().InRoom)
            {
                Room Room = Session.GetHabbo().CurrentRoom;

                if (Room == null)
                {
                    return;
                }

                RoomUser User = Room.GetRoomUserByHabbo(Session.GetHabbo().Id);

                if (User == null)
                {
                    return;
                }

                ServerMessage RoomUpdate = new ServerMessage(266);
                RoomUpdate.AppendInt32(User.VirtualId);
                RoomUpdate.AppendStringWithBreak(Session.GetHabbo().Look);
                RoomUpdate.AppendStringWithBreak(Session.GetHabbo().Gender.ToLower());
                RoomUpdate.AppendStringWithBreak(Session.GetHabbo().Motto);
                Room.SendMessage(RoomUpdate);
            }
        }

        private void GetWardrobe()
        {
            GetResponse().Init(267);
            GetResponse().AppendBoolean(Session.GetHabbo().HasFuse("fuse_use_wardrobe"));

            if (Session.GetHabbo().HasFuse("fuse_use_wardrobe"))
            {
                using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
                {
                    dbClient.AddParamWithValue("userid", Session.GetHabbo().Id);
                    DataTable WardrobeData = dbClient.ReadDataTable("SELECT slot_id, look, gender FROM user_wardrobe WHERE user_id = @userid;");

                    if (WardrobeData == null)
                    {
                        GetResponse().AppendInt32(0);
                    }
                    else
                    {
                        GetResponse().AppendInt32(WardrobeData.Rows.Count);

                        foreach (DataRow Row in WardrobeData.Rows)
                        {
                            GetResponse().AppendUInt((uint)Row["slot_id"]);
                            GetResponse().AppendStringWithBreak((string)Row["look"]);
                            GetResponse().AppendStringWithBreak((string)Row["gender"]);
                        }
                    }
                }

                SendResponse();
            }
        }

        private void SaveWardrobe()
        {
            uint SlotId = Request.PopWiredUInt();

            string Look = Request.PopFixedString();
            string Gender = Request.PopFixedString();

            if (!AntiMutant.ValidateLook(Look, Gender))
            {
                return;
            }

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                dbClient.AddParamWithValue("userid", Session.GetHabbo().Id);
                dbClient.AddParamWithValue("slotid", SlotId);
                dbClient.AddParamWithValue("look", Look);
                dbClient.AddParamWithValue("gender", Gender.ToUpper());

                if (dbClient.ReadDataRow("SELECT null FROM user_wardrobe WHERE user_id = @userid AND slot_id = @slotid LIMIT 1") != null)
                {
                    dbClient.ExecuteQuery("UPDATE user_wardrobe SET look = @look, gender = @gender WHERE user_id = @userid AND slot_id = @slotid LIMIT 1;");
                }
                else
                {
                    dbClient.ExecuteQuery("INSERT INTO user_wardrobe (user_id,slot_id,look,gender) VALUES (@userid,@slotid,@look,@gender)");
                }
            }
        }

        private void GetPetsInventory()
        {
            if (Session.GetHabbo().GetInventoryComponent() == null)
            {
                return;
            }

            Session.SendMessage(Session.GetHabbo().GetInventoryComponent().SerializePetInventory());
        }

        internal void RegisterUsers()
        {
            RequestHandlers.Add(7, new RequestHandler(GetUserInfo));
            RequestHandlers.Add(8, new RequestHandler(GetBalance));
            RequestHandlers.Add(26, new RequestHandler(GetSubscriptionData));

            RequestHandlers.Add(157, new RequestHandler(GetBadges));
            RequestHandlers.Add(158, new RequestHandler(UpdateBadges));
            RequestHandlers.Add(370, new RequestHandler(GetAchievements));

            RequestHandlers.Add(44, new RequestHandler(ChangeLook));
            RequestHandlers.Add(375, new RequestHandler(GetWardrobe));
            RequestHandlers.Add(376, new RequestHandler(SaveWardrobe));

            RequestHandlers.Add(404, new RequestHandler(GetInventory));
            RequestHandlers.Add(3000, new RequestHandler(GetPetsInventory));
        }
    }
}
