﻿using System;
using System.Net.Sockets;
using Butterfly.Core;

namespace Butterfly.Net
{
    class TcpConnectionManager
    {
        //private readonly int MAX_SIMULTANEOUS_CONNECTIONS = 500;

        //private Dictionary<uint, TcpConnection> Connections;
        private TcpConnection[] Connections;
        private TcpConnectionListener Listener;

        //internal int AmountOfActiveConnections
        //{
        //    get
        //    {
        //        //return Connections.Count;
        //        int Count = 0;
        //        for (int i = 0; i < Connections.Length; i++)
        //        {
        //            if (Connections[i] != null)
        //                Count++;
        //        }
        //        return Count;
        //    }
        //}

        internal TcpConnectionManager(int Port, int maxSimultaneousConnections)
        {
            Connections = new TcpConnection[maxSimultaneousConnections]; //new Dictionary<uint, TcpConnection>(maxSimultaneousConnections);
            Listener = new TcpConnectionListener(Port, this);
        }

        internal void DestroyManager()
        {
            for (int i = 0; i < Connections.Length; i++)
            {
                if (Connections[i] != null)
                    Connections[i].Dispose();
            }
            //Connections = null;
            //Listener = null;
        }

        //internal Boolean ContainsConnection(uint Id)
        //{
        //    return (Connections[Id] != null);
        //}

        //internal TcpConnection GetConnection(uint Id)
        //{
        //    //if (Connections.ContainsKey(Id))
        //    //{
        //    //    return Connections[Id];
        //    //}

        //    //return null;
        //    return Connections[Id];
        //}

        internal TcpConnectionListener GetListener()
        {
            return Listener;
        }

        internal int GenerateConnectionID()
        {
            return Array.IndexOf(Connections, null);
        }

        internal void HandleNewConnection(SocketInformation connectioninfo, int PreconnID)
        {
            //if (AmountOfActiveConnections >= MAX_SIMULTANEOUS_CONNECTIONS)
            //    return;

            //Connections.Add(connection.ID, connection);

            TcpConnection Connection = new TcpConnection(Convert.ToUInt16(PreconnID), connectioninfo);

            Connections[PreconnID] = Connection;
            ButterflyEnvironment.GetGame().GetClientManager().CreateAndStartClient((uint)PreconnID, ref Connection);

            Logging.WriteLine("[" + Connection.ipAddress + "] -> [" + PreconnID + "]");
        }

        internal void DropConnection(uint Id)
        {
            //Logging.WriteLine("Dropped connection [" + Id + "]");

            //Connection.Dispose();
            Connections[Id] = null;
        }

        internal void Shutdown()
        {
            Listener.Close();

            for (int i = 0; i < Connections.Length; i++)
            {
                if (Connections[i] == null)
                    continue;
                Connections[i].Dispose();
            }
        }
    }
}
